import "./cljs_env.js";
import "./cljs.core.js";
import "./sci.impl.cljs.js";
import "./sci.impl.macros.js";
import "./sci.impl.utils.js";
import "./sci.lang.js";
goog.provide('sci.impl.copy_vars');
sci.impl.copy_vars.inlined_vars = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 90, [new cljs.core.Symbol(null,"+'","+'",1839585344,null),"null",new cljs.core.Symbol(null,"unchecked-remainder-int","unchecked-remainder-int",1427188224,null),"null",new cljs.core.Symbol(null,"unchecked-subtract-int","unchecked-subtract-int",-1899147615,null),"null",new cljs.core.Symbol(null,"dec'","dec'",1382902561,null),"null",new cljs.core.Symbol(null,"short-array","short-array",-395185918,null),"null",new cljs.core.Symbol(null,"bit-shift-right","bit-shift-right",884046498,null),"null",new cljs.core.Symbol(null,"aget","aget",1491056546,null),"null",new cljs.core.Symbol(null,"=","=",-1501502141,null),"null",new cljs.core.Symbol(null,"boolean","boolean",-278886877,null),"null",new cljs.core.Symbol(null,"bit-shift-left","bit-shift-left",-1814765981,null),"null",new cljs.core.Symbol(null,"aclone","aclone",722978531,null),"null",new cljs.core.Symbol(null,"dec","dec",-766002333,null),"null",new cljs.core.Symbol(null,"<","<",993667236,null),"null",new cljs.core.Symbol(null,"char","char",998943941,null),"null",new cljs.core.Symbol(null,"unchecked-long","unchecked-long",1306610949,null),"null",new cljs.core.Symbol(null,"unchecked-negate","unchecked-negate",-1669067451,null),"null",new cljs.core.Symbol(null,"unchecked-inc-int","unchecked-inc-int",1402783397,null),"null",new cljs.core.Symbol(null,"floats","floats",513591110,null),"null",new cljs.core.Symbol(null,"pos?","pos?",-244377722,null),"null",new cljs.core.Symbol(null,"boolean-array","boolean-array",-640353913,null),"null",new cljs.core.Symbol(null,"alength","alength",-1268305401,null),"null",new cljs.core.Symbol(null,"bit-xor","bit-xor",-1334295033,null),"null",new cljs.core.Symbol(null,"unsigned-bit-shift-right","unsigned-bit-shift-right",-1953076601,null),"null",new cljs.core.Symbol(null,"neg?","neg?",-1902175577,null),"null",new cljs.core.Symbol(null,"unchecked-float","unchecked-float",1485658216,null),"null",new cljs.core.Symbol(null,"num","num",-669195096,null),"null",new cljs.core.Symbol(null,"reduced?","reduced?",1361797384,null),"null",new cljs.core.Symbol(null,"booleans","booleans",756846088,null),"null",new cljs.core.Symbol(null,"int-array","int-array",459176616,null),"null",new cljs.core.Symbol(null,"inc'","inc'",1740049128,null),"null",new cljs.core.Symbol(null,"<=","<=",1244895369,null),"null",new cljs.core.Symbol(null,"-'","-'",1770549449,null),"null",new cljs.core.Symbol(null,"*","*",345799209,null),"null",new cljs.core.Symbol(null,"min","min",2085523049,null),"null",new cljs.core.Symbol(null,"get","get",-971253014,null),"null",new cljs.core.Symbol(null,"long","long",1469079434,null),"null",new cljs.core.Symbol(null,"double","double",-1769548886,null),"null",new cljs.core.Symbol(null,"bit-and-not","bit-and-not",-254338837,null),"null",new cljs.core.Symbol(null,"unchecked-add-int","unchecked-add-int",-1821763285,null),"null",new cljs.core.Symbol(null,"short","short",-725675253,null),"null",new cljs.core.Symbol(null,"quot","quot",-1125214196,null),"null",new cljs.core.Symbol(null,"unchecked-double","unchecked-double",-1593778036,null),"null",new cljs.core.Symbol(null,"longs","longs",-1017696020,null),"null",new cljs.core.Symbol(null,"unchecked-multiply-int","unchecked-multiply-int",-788546068,null),"null",new cljs.core.Symbol(null,"int","int",-100885395,null),"null",new cljs.core.Symbol(null,">",">",1085014381,null),"null",new cljs.core.Symbol(null,"unchecked-int","unchecked-int",1672898125,null),"null",new cljs.core.Symbol(null,"unchecked-multiply","unchecked-multiply",-1019161490,null),"null",new cljs.core.Symbol(null,"unchecked-dec","unchecked-dec",2095823150,null),"null",new cljs.core.Symbol(null,"double-array","double-array",257035726,null),"null",new cljs.core.Symbol(null,"float","float",-91857841,null),"null",new cljs.core.Symbol(null,"-","-",-471816912,null),"null",new cljs.core.Symbol(null,"byte-array","byte-array",2009690064,null),"null",new cljs.core.Symbol(null,"zero?","zero?",325758897,null),"null",new cljs.core.Symbol(null,"unchecked-dec-int","unchecked-dec-int",1339067442,null),"null",new cljs.core.Symbol(null,"rem","rem",664046770,null),"null",new cljs.core.Symbol(null,"nth","nth",1529209554,null),"null",new cljs.core.Symbol(null,"nil?","nil?",1612038930,null),"null",new cljs.core.Symbol(null,"bit-and","bit-and",-479352589,null),"null",new cljs.core.Symbol(null,"*'","*'",-1403126253,null),"null",new cljs.core.Symbol(null,"unchecked-add","unchecked-add",-2030665965,null),"null",new cljs.core.Symbol(null,"identical?","identical?",-745864205,null),"null",new cljs.core.Symbol(null,"unchecked-divide-int","unchecked-divide-int",1613116468,null),"null",new cljs.core.Symbol(null,"unchecked-subtract","unchecked-subtract",-2137458667,null),"null",new cljs.core.Symbol(null,"/","/",-1371932971,null),"null",new cljs.core.Symbol(null,"bit-or","bit-or",-1144943723,null),"null",new cljs.core.Symbol(null,">=",">=",1016916022,null),"null",new cljs.core.Symbol(null,"long-array","long-array",217579190,null),"null",new cljs.core.Symbol(null,"object-array","object-array",206434647,null),"null",new cljs.core.Symbol(null,"doubles","doubles",-1517872169,null),"null",new cljs.core.Symbol(null,"unchecked-byte","unchecked-byte",1091664664,null),"null",new cljs.core.Symbol(null,"unchecked-short","unchecked-short",27848057,null),"null",new cljs.core.Symbol(null,"float-array","float-array",2043038265,null),"null",new cljs.core.Symbol(null,"inc","inc",324505433,null),"null",new cljs.core.Symbol(null,"+","+",-740910886,null),"null",new cljs.core.Symbol(null,"aset","aset",900773178,null),"null",new cljs.core.Symbol(null,"chars","chars",545901210,null),"null",new cljs.core.Symbol(null,"ints","ints",-1761239845,null),"null",new cljs.core.Symbol(null,"bit-not","bit-not",1508529851,null),"null",new cljs.core.Symbol(null,"byte","byte",-1970660549,null),"null",new cljs.core.Symbol(null,"max","max",1701898075,null),"null",new cljs.core.Symbol(null,"==","==",-234118149,null),"null",new cljs.core.Symbol(null,"count","count",-514511684,null),"null",new cljs.core.Symbol(null,"char-array","char-array",1338149341,null),"null",new cljs.core.Symbol(null,"compare","compare",1109853757,null),"null",new cljs.core.Symbol(null,"shorts","shorts",107738238,null),"null",new cljs.core.Symbol(null,"unchecked-negate-int","unchecked-negate-int",-825297602,null),"null",new cljs.core.Symbol(null,"unchecked-inc","unchecked-inc",-1170131490,null),"null",new cljs.core.Symbol(null,"unchecked-char","unchecked-char",1662742943,null),"null",new cljs.core.Symbol(null,"bytes","bytes",-1478569089,null),"null"], null), null);
sci.impl.copy_vars.cljs_resolve = (((typeof cljs !== 'undefined') && (typeof cljs.analyzer !== 'undefined') && (typeof cljs.analyzer.api !== 'undefined') && (typeof cljs.analyzer.api.resolve !== 'undefined'))?(new cljs.core.Var((function (){
return cljs.analyzer.api.resolve;
}),cljs.core.with_meta(new cljs.core.Symbol("cljs.analyzer.api","resolve","cljs.analyzer.api/resolve",498213843,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword("cljs.analyzer","no-resolve","cljs.analyzer/no-resolve",-1872351017),true], null)),null)):null);
sci.impl.copy_vars.elide_vars = false;
sci.impl.copy_vars.macrofy_STAR_ = (function sci$impl$copy_vars$macrofy_STAR_(var_args){
var G__36406 = arguments.length;
switch (G__36406) {
case 1:
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.vary_meta.cljs$core$IFn$_invoke$arity$2(f,(function (p1__36402_SHARP_){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__36402_SHARP_,new cljs.core.Keyword("sci","macro","sci/macro",-868536151),true);
}));
}));

(sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (sym,f){
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$4(sym,f,null,false);
}));

(sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$3 = (function (sym,f,ns){
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$4(sym,f,ns,false);
}));

(sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$4 = (function (sym,f,ns,ctx_QMARK_){
return sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$5(sym,f,ns,ctx_QMARK_,null);
}));

(sci.impl.copy_vars.macrofy_STAR_.cljs$core$IFn$_invoke$arity$5 = (function (sym,f,ns,ctx_QMARK_,extra_meta){
var ns__$1 = (function (){var or__5045__auto__ = ns;
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return sci.impl.utils.clojure_core_ns;
}
})();
return sci.impl.utils.new_var.cljs$core$IFn$_invoke$arity$4(sym,f,(function (){var G__36412 = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"ns","ns",441598760),ns__$1,new cljs.core.Keyword(null,"macro","macro",-867863404),true,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true], null);
if(cljs.core.truth_((function (){var and__5043__auto__ = (!(sci.impl.copy_vars.elide_vars));
if(and__5043__auto__){
return extra_meta;
} else {
return and__5043__auto__;
}
})())){
return cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([G__36412,extra_meta], 0));
} else {
return G__36412;
}
})(),ctx_QMARK_);
}));

(sci.impl.copy_vars.macrofy_STAR_.cljs$lang$maxFixedArity = 5);

sci.impl.copy_vars.new_var = (function sci$impl$copy_vars$new_var(var_args){
var G__36415 = arguments.length;
switch (G__36415) {
case 2:
return sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$2 = (function (sym,f){
return sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$4(sym,f,null,false);
}));

(sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$3 = (function (sym,f,ns){
return sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$4(sym,f,ns,false);
}));

(sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$4 = (function (sym,f,ns,ctx_QMARK_){
return sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$5(sym,f,ns,ctx_QMARK_,null);
}));

(sci.impl.copy_vars.new_var.cljs$core$IFn$_invoke$arity$5 = (function (sym,f,ns,ctx_QMARK_,extra_meta){
var ctx_QMARK___$1 = (function (){var or__5045__auto__ = ctx_QMARK_;
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return ns === true;
}
})();
var ns__$1 = ((ns === true)?sci.impl.utils.clojure_core_ns:(function (){var or__5045__auto__ = ns;
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return sci.impl.utils.clojure_core_ns;
}
})());
if((((!(cljs.core.boolean_QMARK_(ns__$1)))) && ((ns__$1 instanceof sci.lang.Namespace)))){
} else {
throw (new Error(["Assert failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(sym),"\n","(and (not (boolean? ns)) (instance? sci.lang.Namespace ns))"].join('')));
}

return sci.impl.utils.new_var.cljs$core$IFn$_invoke$arity$4(sym,f,(function (){var G__36435 = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"ns","ns",441598760),ns__$1,new cljs.core.Keyword("sci","built-in","sci/built-in",1244659599),true], null);
if(cljs.core.truth_((function (){var and__5043__auto__ = (!(sci.impl.copy_vars.elide_vars));
if(and__5043__auto__){
return extra_meta;
} else {
return and__5043__auto__;
}
})())){
return cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([G__36435,extra_meta], 0));
} else {
return G__36435;
}
})(),ctx_QMARK___$1);
}));

(sci.impl.copy_vars.new_var.cljs$lang$maxFixedArity = 5);


//# sourceMappingURL=sci.impl.copy_vars.js.map
