import "./cljs_env.js";
import "./cljs.core.js";
import "./sci.impl.types.js";
import "./sci.impl.utils.js";
goog.provide('sci.impl.fns');
sci.impl.fns.fun = (function sci$impl$fns$fun(var_args){
var G__34128 = arguments.length;
switch (G__34128) {
case 5:
return sci.impl.fns.fun.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 11:
return sci.impl.fns.fun.cljs$core$IFn$_invoke$arity$11((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]),(arguments[(6)]),(arguments[(7)]),(arguments[(8)]),(arguments[(9)]),(arguments[(10)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.fns.fun.cljs$core$IFn$_invoke$arity$5 = (function (ctx,enclosed_array,fn_body,fn_name,macro_QMARK_){
return sci.impl.fns.fun.cljs$core$IFn$_invoke$arity$11(ctx,enclosed_array,fn_body,fn_name,macro_QMARK_,new cljs.core.Keyword(null,"fixed-arity","fixed-arity",1586445869).cljs$core$IFn$_invoke$arity$1(fn_body),new cljs.core.Keyword(null,"copy-enclosed->invocation","copy-enclosed->invocation",-1322388729).cljs$core$IFn$_invoke$arity$1(fn_body),new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(fn_body),new cljs.core.Keyword(null,"invoc-size","invoc-size",2053298058).cljs$core$IFn$_invoke$arity$1(fn_body),sci.impl.utils.current_ns_name(),new cljs.core.Keyword(null,"vararg-idx","vararg-idx",-590991228).cljs$core$IFn$_invoke$arity$1(fn_body));
}));

(sci.impl.fns.fun.cljs$core$IFn$_invoke$arity$11 = (function (ctx,enclosed_array,fn_body,fn_name,macro_QMARK_,fixed_arity,enclosed__GT_invocation,body,invoc_size,nsm,vararg_idx){
var f = (cljs.core.truth_(vararg_idx)?(function (){var G__34143 = fixed_arity;
switch (G__34143) {
case (0):
return (function() { 
var sci$impl$fns$arity_0__delegate = function (G__34149){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[vararg_idx] = G__34149);

while(true){
var ret__33493__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33493__auto__)){
continue;
} else {
return ret__33493__auto__;
}
break;
}
};
var sci$impl$fns$arity_0 = function (var_args){
var G__34149 = null;
if (arguments.length > 0) {
var G__34923__i = 0, G__34923__a = new Array(arguments.length -  0);
while (G__34923__i < G__34923__a.length) {G__34923__a[G__34923__i] = arguments[G__34923__i + 0]; ++G__34923__i;}
  G__34149 = new cljs.core.IndexedSeq(G__34923__a,0,null);
} 
return sci$impl$fns$arity_0__delegate.call(this,G__34149);};
sci$impl$fns$arity_0.cljs$lang$maxFixedArity = 0;
sci$impl$fns$arity_0.cljs$lang$applyTo = (function (arglist__34924){
var G__34149 = cljs.core.seq(arglist__34924);
return sci$impl$fns$arity_0__delegate(G__34149);
});
sci$impl$fns$arity_0.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_0__delegate;
return sci$impl$fns$arity_0;
})()
;

break;
case (1):
return (function() { 
var sci$impl$fns$arity_1__delegate = function (G__34150,G__34151){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34150);

(invoc_array[vararg_idx] = G__34151);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_1 = function (G__34150,var_args){
var G__34151 = null;
if (arguments.length > 1) {
var G__34925__i = 0, G__34925__a = new Array(arguments.length -  1);
while (G__34925__i < G__34925__a.length) {G__34925__a[G__34925__i] = arguments[G__34925__i + 1]; ++G__34925__i;}
  G__34151 = new cljs.core.IndexedSeq(G__34925__a,0,null);
} 
return sci$impl$fns$arity_1__delegate.call(this,G__34150,G__34151);};
sci$impl$fns$arity_1.cljs$lang$maxFixedArity = 1;
sci$impl$fns$arity_1.cljs$lang$applyTo = (function (arglist__34926){
var G__34150 = cljs.core.first(arglist__34926);
var G__34151 = cljs.core.rest(arglist__34926);
return sci$impl$fns$arity_1__delegate(G__34150,G__34151);
});
sci$impl$fns$arity_1.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_1__delegate;
return sci$impl$fns$arity_1;
})()
;

break;
case (2):
return (function() { 
var sci$impl$fns$arity_2__delegate = function (G__34158,G__34159,G__34160){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34158);

(invoc_array[(1)] = G__34159);

(invoc_array[vararg_idx] = G__34160);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_2 = function (G__34158,G__34159,var_args){
var G__34160 = null;
if (arguments.length > 2) {
var G__34927__i = 0, G__34927__a = new Array(arguments.length -  2);
while (G__34927__i < G__34927__a.length) {G__34927__a[G__34927__i] = arguments[G__34927__i + 2]; ++G__34927__i;}
  G__34160 = new cljs.core.IndexedSeq(G__34927__a,0,null);
} 
return sci$impl$fns$arity_2__delegate.call(this,G__34158,G__34159,G__34160);};
sci$impl$fns$arity_2.cljs$lang$maxFixedArity = 2;
sci$impl$fns$arity_2.cljs$lang$applyTo = (function (arglist__34929){
var G__34158 = cljs.core.first(arglist__34929);
arglist__34929 = cljs.core.next(arglist__34929);
var G__34159 = cljs.core.first(arglist__34929);
var G__34160 = cljs.core.rest(arglist__34929);
return sci$impl$fns$arity_2__delegate(G__34158,G__34159,G__34160);
});
sci$impl$fns$arity_2.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_2__delegate;
return sci$impl$fns$arity_2;
})()
;

break;
case (3):
return (function() { 
var sci$impl$fns$arity_3__delegate = function (G__34161,G__34162,G__34163,G__34164){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34161);

(invoc_array[(1)] = G__34162);

(invoc_array[(2)] = G__34163);

(invoc_array[vararg_idx] = G__34164);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_3 = function (G__34161,G__34162,G__34163,var_args){
var G__34164 = null;
if (arguments.length > 3) {
var G__34937__i = 0, G__34937__a = new Array(arguments.length -  3);
while (G__34937__i < G__34937__a.length) {G__34937__a[G__34937__i] = arguments[G__34937__i + 3]; ++G__34937__i;}
  G__34164 = new cljs.core.IndexedSeq(G__34937__a,0,null);
} 
return sci$impl$fns$arity_3__delegate.call(this,G__34161,G__34162,G__34163,G__34164);};
sci$impl$fns$arity_3.cljs$lang$maxFixedArity = 3;
sci$impl$fns$arity_3.cljs$lang$applyTo = (function (arglist__34938){
var G__34161 = cljs.core.first(arglist__34938);
arglist__34938 = cljs.core.next(arglist__34938);
var G__34162 = cljs.core.first(arglist__34938);
arglist__34938 = cljs.core.next(arglist__34938);
var G__34163 = cljs.core.first(arglist__34938);
var G__34164 = cljs.core.rest(arglist__34938);
return sci$impl$fns$arity_3__delegate(G__34161,G__34162,G__34163,G__34164);
});
sci$impl$fns$arity_3.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_3__delegate;
return sci$impl$fns$arity_3;
})()
;

break;
case (4):
return (function() { 
var sci$impl$fns$arity_4__delegate = function (G__34170,G__34171,G__34172,G__34173,G__34174){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34170);

(invoc_array[(1)] = G__34171);

(invoc_array[(2)] = G__34172);

(invoc_array[(3)] = G__34173);

(invoc_array[vararg_idx] = G__34174);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_4 = function (G__34170,G__34171,G__34172,G__34173,var_args){
var G__34174 = null;
if (arguments.length > 4) {
var G__34939__i = 0, G__34939__a = new Array(arguments.length -  4);
while (G__34939__i < G__34939__a.length) {G__34939__a[G__34939__i] = arguments[G__34939__i + 4]; ++G__34939__i;}
  G__34174 = new cljs.core.IndexedSeq(G__34939__a,0,null);
} 
return sci$impl$fns$arity_4__delegate.call(this,G__34170,G__34171,G__34172,G__34173,G__34174);};
sci$impl$fns$arity_4.cljs$lang$maxFixedArity = 4;
sci$impl$fns$arity_4.cljs$lang$applyTo = (function (arglist__34940){
var G__34170 = cljs.core.first(arglist__34940);
arglist__34940 = cljs.core.next(arglist__34940);
var G__34171 = cljs.core.first(arglist__34940);
arglist__34940 = cljs.core.next(arglist__34940);
var G__34172 = cljs.core.first(arglist__34940);
arglist__34940 = cljs.core.next(arglist__34940);
var G__34173 = cljs.core.first(arglist__34940);
var G__34174 = cljs.core.rest(arglist__34940);
return sci$impl$fns$arity_4__delegate(G__34170,G__34171,G__34172,G__34173,G__34174);
});
sci$impl$fns$arity_4.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_4__delegate;
return sci$impl$fns$arity_4;
})()
;

break;
case (5):
return (function() { 
var sci$impl$fns$arity_5__delegate = function (G__34175,G__34176,G__34177,G__34178,G__34179,G__34180){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34175);

(invoc_array[(1)] = G__34176);

(invoc_array[(2)] = G__34177);

(invoc_array[(3)] = G__34178);

(invoc_array[(4)] = G__34179);

(invoc_array[vararg_idx] = G__34180);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_5 = function (G__34175,G__34176,G__34177,G__34178,G__34179,var_args){
var G__34180 = null;
if (arguments.length > 5) {
var G__34941__i = 0, G__34941__a = new Array(arguments.length -  5);
while (G__34941__i < G__34941__a.length) {G__34941__a[G__34941__i] = arguments[G__34941__i + 5]; ++G__34941__i;}
  G__34180 = new cljs.core.IndexedSeq(G__34941__a,0,null);
} 
return sci$impl$fns$arity_5__delegate.call(this,G__34175,G__34176,G__34177,G__34178,G__34179,G__34180);};
sci$impl$fns$arity_5.cljs$lang$maxFixedArity = 5;
sci$impl$fns$arity_5.cljs$lang$applyTo = (function (arglist__34942){
var G__34175 = cljs.core.first(arglist__34942);
arglist__34942 = cljs.core.next(arglist__34942);
var G__34176 = cljs.core.first(arglist__34942);
arglist__34942 = cljs.core.next(arglist__34942);
var G__34177 = cljs.core.first(arglist__34942);
arglist__34942 = cljs.core.next(arglist__34942);
var G__34178 = cljs.core.first(arglist__34942);
arglist__34942 = cljs.core.next(arglist__34942);
var G__34179 = cljs.core.first(arglist__34942);
var G__34180 = cljs.core.rest(arglist__34942);
return sci$impl$fns$arity_5__delegate(G__34175,G__34176,G__34177,G__34178,G__34179,G__34180);
});
sci$impl$fns$arity_5.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_5__delegate;
return sci$impl$fns$arity_5;
})()
;

break;
case (6):
return (function() { 
var sci$impl$fns$arity_6__delegate = function (G__34185,G__34186,G__34187,G__34188,G__34189,G__34190,G__34191){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34185);

(invoc_array[(1)] = G__34186);

(invoc_array[(2)] = G__34187);

(invoc_array[(3)] = G__34188);

(invoc_array[(4)] = G__34189);

(invoc_array[(5)] = G__34190);

(invoc_array[vararg_idx] = G__34191);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_6 = function (G__34185,G__34186,G__34187,G__34188,G__34189,G__34190,var_args){
var G__34191 = null;
if (arguments.length > 6) {
var G__34943__i = 0, G__34943__a = new Array(arguments.length -  6);
while (G__34943__i < G__34943__a.length) {G__34943__a[G__34943__i] = arguments[G__34943__i + 6]; ++G__34943__i;}
  G__34191 = new cljs.core.IndexedSeq(G__34943__a,0,null);
} 
return sci$impl$fns$arity_6__delegate.call(this,G__34185,G__34186,G__34187,G__34188,G__34189,G__34190,G__34191);};
sci$impl$fns$arity_6.cljs$lang$maxFixedArity = 6;
sci$impl$fns$arity_6.cljs$lang$applyTo = (function (arglist__34944){
var G__34185 = cljs.core.first(arglist__34944);
arglist__34944 = cljs.core.next(arglist__34944);
var G__34186 = cljs.core.first(arglist__34944);
arglist__34944 = cljs.core.next(arglist__34944);
var G__34187 = cljs.core.first(arglist__34944);
arglist__34944 = cljs.core.next(arglist__34944);
var G__34188 = cljs.core.first(arglist__34944);
arglist__34944 = cljs.core.next(arglist__34944);
var G__34189 = cljs.core.first(arglist__34944);
arglist__34944 = cljs.core.next(arglist__34944);
var G__34190 = cljs.core.first(arglist__34944);
var G__34191 = cljs.core.rest(arglist__34944);
return sci$impl$fns$arity_6__delegate(G__34185,G__34186,G__34187,G__34188,G__34189,G__34190,G__34191);
});
sci$impl$fns$arity_6.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_6__delegate;
return sci$impl$fns$arity_6;
})()
;

break;
case (7):
return (function() { 
var sci$impl$fns$arity_7__delegate = function (G__34195,G__34196,G__34197,G__34198,G__34199,G__34200,G__34201,G__34202){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34195);

(invoc_array[(1)] = G__34196);

(invoc_array[(2)] = G__34197);

(invoc_array[(3)] = G__34198);

(invoc_array[(4)] = G__34199);

(invoc_array[(5)] = G__34200);

(invoc_array[(6)] = G__34201);

(invoc_array[vararg_idx] = G__34202);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_7 = function (G__34195,G__34196,G__34197,G__34198,G__34199,G__34200,G__34201,var_args){
var G__34202 = null;
if (arguments.length > 7) {
var G__34945__i = 0, G__34945__a = new Array(arguments.length -  7);
while (G__34945__i < G__34945__a.length) {G__34945__a[G__34945__i] = arguments[G__34945__i + 7]; ++G__34945__i;}
  G__34202 = new cljs.core.IndexedSeq(G__34945__a,0,null);
} 
return sci$impl$fns$arity_7__delegate.call(this,G__34195,G__34196,G__34197,G__34198,G__34199,G__34200,G__34201,G__34202);};
sci$impl$fns$arity_7.cljs$lang$maxFixedArity = 7;
sci$impl$fns$arity_7.cljs$lang$applyTo = (function (arglist__34946){
var G__34195 = cljs.core.first(arglist__34946);
arglist__34946 = cljs.core.next(arglist__34946);
var G__34196 = cljs.core.first(arglist__34946);
arglist__34946 = cljs.core.next(arglist__34946);
var G__34197 = cljs.core.first(arglist__34946);
arglist__34946 = cljs.core.next(arglist__34946);
var G__34198 = cljs.core.first(arglist__34946);
arglist__34946 = cljs.core.next(arglist__34946);
var G__34199 = cljs.core.first(arglist__34946);
arglist__34946 = cljs.core.next(arglist__34946);
var G__34200 = cljs.core.first(arglist__34946);
arglist__34946 = cljs.core.next(arglist__34946);
var G__34201 = cljs.core.first(arglist__34946);
var G__34202 = cljs.core.rest(arglist__34946);
return sci$impl$fns$arity_7__delegate(G__34195,G__34196,G__34197,G__34198,G__34199,G__34200,G__34201,G__34202);
});
sci$impl$fns$arity_7.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_7__delegate;
return sci$impl$fns$arity_7;
})()
;

break;
case (8):
return (function() { 
var sci$impl$fns$arity_8__delegate = function (G__34205,G__34206,G__34207,G__34208,G__34209,G__34210,G__34211,G__34212,G__34213){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34205);

(invoc_array[(1)] = G__34206);

(invoc_array[(2)] = G__34207);

(invoc_array[(3)] = G__34208);

(invoc_array[(4)] = G__34209);

(invoc_array[(5)] = G__34210);

(invoc_array[(6)] = G__34211);

(invoc_array[(7)] = G__34212);

(invoc_array[vararg_idx] = G__34213);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_8 = function (G__34205,G__34206,G__34207,G__34208,G__34209,G__34210,G__34211,G__34212,var_args){
var G__34213 = null;
if (arguments.length > 8) {
var G__34948__i = 0, G__34948__a = new Array(arguments.length -  8);
while (G__34948__i < G__34948__a.length) {G__34948__a[G__34948__i] = arguments[G__34948__i + 8]; ++G__34948__i;}
  G__34213 = new cljs.core.IndexedSeq(G__34948__a,0,null);
} 
return sci$impl$fns$arity_8__delegate.call(this,G__34205,G__34206,G__34207,G__34208,G__34209,G__34210,G__34211,G__34212,G__34213);};
sci$impl$fns$arity_8.cljs$lang$maxFixedArity = 8;
sci$impl$fns$arity_8.cljs$lang$applyTo = (function (arglist__34949){
var G__34205 = cljs.core.first(arglist__34949);
arglist__34949 = cljs.core.next(arglist__34949);
var G__34206 = cljs.core.first(arglist__34949);
arglist__34949 = cljs.core.next(arglist__34949);
var G__34207 = cljs.core.first(arglist__34949);
arglist__34949 = cljs.core.next(arglist__34949);
var G__34208 = cljs.core.first(arglist__34949);
arglist__34949 = cljs.core.next(arglist__34949);
var G__34209 = cljs.core.first(arglist__34949);
arglist__34949 = cljs.core.next(arglist__34949);
var G__34210 = cljs.core.first(arglist__34949);
arglist__34949 = cljs.core.next(arglist__34949);
var G__34211 = cljs.core.first(arglist__34949);
arglist__34949 = cljs.core.next(arglist__34949);
var G__34212 = cljs.core.first(arglist__34949);
var G__34213 = cljs.core.rest(arglist__34949);
return sci$impl$fns$arity_8__delegate(G__34205,G__34206,G__34207,G__34208,G__34209,G__34210,G__34211,G__34212,G__34213);
});
sci$impl$fns$arity_8.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_8__delegate;
return sci$impl$fns$arity_8;
})()
;

break;
case (9):
return (function() { 
var sci$impl$fns$arity_9__delegate = function (G__34217,G__34218,G__34219,G__34220,G__34221,G__34222,G__34223,G__34224,G__34225,G__34226){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34217);

(invoc_array[(1)] = G__34218);

(invoc_array[(2)] = G__34219);

(invoc_array[(3)] = G__34220);

(invoc_array[(4)] = G__34221);

(invoc_array[(5)] = G__34222);

(invoc_array[(6)] = G__34223);

(invoc_array[(7)] = G__34224);

(invoc_array[(8)] = G__34225);

(invoc_array[vararg_idx] = G__34226);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_9 = function (G__34217,G__34218,G__34219,G__34220,G__34221,G__34222,G__34223,G__34224,G__34225,var_args){
var G__34226 = null;
if (arguments.length > 9) {
var G__34950__i = 0, G__34950__a = new Array(arguments.length -  9);
while (G__34950__i < G__34950__a.length) {G__34950__a[G__34950__i] = arguments[G__34950__i + 9]; ++G__34950__i;}
  G__34226 = new cljs.core.IndexedSeq(G__34950__a,0,null);
} 
return sci$impl$fns$arity_9__delegate.call(this,G__34217,G__34218,G__34219,G__34220,G__34221,G__34222,G__34223,G__34224,G__34225,G__34226);};
sci$impl$fns$arity_9.cljs$lang$maxFixedArity = 9;
sci$impl$fns$arity_9.cljs$lang$applyTo = (function (arglist__34951){
var G__34217 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34218 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34219 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34220 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34221 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34222 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34223 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34224 = cljs.core.first(arglist__34951);
arglist__34951 = cljs.core.next(arglist__34951);
var G__34225 = cljs.core.first(arglist__34951);
var G__34226 = cljs.core.rest(arglist__34951);
return sci$impl$fns$arity_9__delegate(G__34217,G__34218,G__34219,G__34220,G__34221,G__34222,G__34223,G__34224,G__34225,G__34226);
});
sci$impl$fns$arity_9.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_9__delegate;
return sci$impl$fns$arity_9;
})()
;

break;
case (10):
return (function() { 
var sci$impl$fns$arity_10__delegate = function (G__34228,G__34229,G__34230,G__34231,G__34232,G__34233,G__34234,G__34235,G__34236,G__34237,G__34238){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34228);

(invoc_array[(1)] = G__34229);

(invoc_array[(2)] = G__34230);

(invoc_array[(3)] = G__34231);

(invoc_array[(4)] = G__34232);

(invoc_array[(5)] = G__34233);

(invoc_array[(6)] = G__34234);

(invoc_array[(7)] = G__34235);

(invoc_array[(8)] = G__34236);

(invoc_array[(9)] = G__34237);

(invoc_array[vararg_idx] = G__34238);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_10 = function (G__34228,G__34229,G__34230,G__34231,G__34232,G__34233,G__34234,G__34235,G__34236,G__34237,var_args){
var G__34238 = null;
if (arguments.length > 10) {
var G__34952__i = 0, G__34952__a = new Array(arguments.length -  10);
while (G__34952__i < G__34952__a.length) {G__34952__a[G__34952__i] = arguments[G__34952__i + 10]; ++G__34952__i;}
  G__34238 = new cljs.core.IndexedSeq(G__34952__a,0,null);
} 
return sci$impl$fns$arity_10__delegate.call(this,G__34228,G__34229,G__34230,G__34231,G__34232,G__34233,G__34234,G__34235,G__34236,G__34237,G__34238);};
sci$impl$fns$arity_10.cljs$lang$maxFixedArity = 10;
sci$impl$fns$arity_10.cljs$lang$applyTo = (function (arglist__34953){
var G__34228 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34229 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34230 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34231 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34232 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34233 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34234 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34235 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34236 = cljs.core.first(arglist__34953);
arglist__34953 = cljs.core.next(arglist__34953);
var G__34237 = cljs.core.first(arglist__34953);
var G__34238 = cljs.core.rest(arglist__34953);
return sci$impl$fns$arity_10__delegate(G__34228,G__34229,G__34230,G__34231,G__34232,G__34233,G__34234,G__34235,G__34236,G__34237,G__34238);
});
sci$impl$fns$arity_10.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_10__delegate;
return sci$impl$fns$arity_10;
})()
;

break;
case (11):
return (function() { 
var sci$impl$fns$arity_11__delegate = function (G__34239,G__34240,G__34241,G__34242,G__34243,G__34244,G__34245,G__34246,G__34247,G__34248,G__34249,G__34250){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34239);

(invoc_array[(1)] = G__34240);

(invoc_array[(2)] = G__34241);

(invoc_array[(3)] = G__34242);

(invoc_array[(4)] = G__34243);

(invoc_array[(5)] = G__34244);

(invoc_array[(6)] = G__34245);

(invoc_array[(7)] = G__34246);

(invoc_array[(8)] = G__34247);

(invoc_array[(9)] = G__34248);

(invoc_array[(10)] = G__34249);

(invoc_array[vararg_idx] = G__34250);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_11 = function (G__34239,G__34240,G__34241,G__34242,G__34243,G__34244,G__34245,G__34246,G__34247,G__34248,G__34249,var_args){
var G__34250 = null;
if (arguments.length > 11) {
var G__34961__i = 0, G__34961__a = new Array(arguments.length -  11);
while (G__34961__i < G__34961__a.length) {G__34961__a[G__34961__i] = arguments[G__34961__i + 11]; ++G__34961__i;}
  G__34250 = new cljs.core.IndexedSeq(G__34961__a,0,null);
} 
return sci$impl$fns$arity_11__delegate.call(this,G__34239,G__34240,G__34241,G__34242,G__34243,G__34244,G__34245,G__34246,G__34247,G__34248,G__34249,G__34250);};
sci$impl$fns$arity_11.cljs$lang$maxFixedArity = 11;
sci$impl$fns$arity_11.cljs$lang$applyTo = (function (arglist__34962){
var G__34239 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34240 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34241 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34242 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34243 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34244 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34245 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34246 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34247 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34248 = cljs.core.first(arglist__34962);
arglist__34962 = cljs.core.next(arglist__34962);
var G__34249 = cljs.core.first(arglist__34962);
var G__34250 = cljs.core.rest(arglist__34962);
return sci$impl$fns$arity_11__delegate(G__34239,G__34240,G__34241,G__34242,G__34243,G__34244,G__34245,G__34246,G__34247,G__34248,G__34249,G__34250);
});
sci$impl$fns$arity_11.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_11__delegate;
return sci$impl$fns$arity_11;
})()
;

break;
case (12):
return (function() { 
var sci$impl$fns$arity_12__delegate = function (G__34253,G__34254,G__34255,G__34256,G__34257,G__34258,G__34259,G__34260,G__34261,G__34262,G__34263,G__34264,G__34265){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34253);

(invoc_array[(1)] = G__34254);

(invoc_array[(2)] = G__34255);

(invoc_array[(3)] = G__34256);

(invoc_array[(4)] = G__34257);

(invoc_array[(5)] = G__34258);

(invoc_array[(6)] = G__34259);

(invoc_array[(7)] = G__34260);

(invoc_array[(8)] = G__34261);

(invoc_array[(9)] = G__34262);

(invoc_array[(10)] = G__34263);

(invoc_array[(11)] = G__34264);

(invoc_array[vararg_idx] = G__34265);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_12 = function (G__34253,G__34254,G__34255,G__34256,G__34257,G__34258,G__34259,G__34260,G__34261,G__34262,G__34263,G__34264,var_args){
var G__34265 = null;
if (arguments.length > 12) {
var G__34963__i = 0, G__34963__a = new Array(arguments.length -  12);
while (G__34963__i < G__34963__a.length) {G__34963__a[G__34963__i] = arguments[G__34963__i + 12]; ++G__34963__i;}
  G__34265 = new cljs.core.IndexedSeq(G__34963__a,0,null);
} 
return sci$impl$fns$arity_12__delegate.call(this,G__34253,G__34254,G__34255,G__34256,G__34257,G__34258,G__34259,G__34260,G__34261,G__34262,G__34263,G__34264,G__34265);};
sci$impl$fns$arity_12.cljs$lang$maxFixedArity = 12;
sci$impl$fns$arity_12.cljs$lang$applyTo = (function (arglist__34964){
var G__34253 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34254 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34255 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34256 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34257 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34258 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34259 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34260 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34261 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34262 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34263 = cljs.core.first(arglist__34964);
arglist__34964 = cljs.core.next(arglist__34964);
var G__34264 = cljs.core.first(arglist__34964);
var G__34265 = cljs.core.rest(arglist__34964);
return sci$impl$fns$arity_12__delegate(G__34253,G__34254,G__34255,G__34256,G__34257,G__34258,G__34259,G__34260,G__34261,G__34262,G__34263,G__34264,G__34265);
});
sci$impl$fns$arity_12.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_12__delegate;
return sci$impl$fns$arity_12;
})()
;

break;
case (13):
return (function() { 
var sci$impl$fns$arity_13__delegate = function (G__34268,G__34269,G__34270,G__34271,G__34272,G__34273,G__34274,G__34275,G__34276,G__34277,G__34278,G__34279,G__34280,G__34281){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34268);

(invoc_array[(1)] = G__34269);

(invoc_array[(2)] = G__34270);

(invoc_array[(3)] = G__34271);

(invoc_array[(4)] = G__34272);

(invoc_array[(5)] = G__34273);

(invoc_array[(6)] = G__34274);

(invoc_array[(7)] = G__34275);

(invoc_array[(8)] = G__34276);

(invoc_array[(9)] = G__34277);

(invoc_array[(10)] = G__34278);

(invoc_array[(11)] = G__34279);

(invoc_array[(12)] = G__34280);

(invoc_array[vararg_idx] = G__34281);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_13 = function (G__34268,G__34269,G__34270,G__34271,G__34272,G__34273,G__34274,G__34275,G__34276,G__34277,G__34278,G__34279,G__34280,var_args){
var G__34281 = null;
if (arguments.length > 13) {
var G__34967__i = 0, G__34967__a = new Array(arguments.length -  13);
while (G__34967__i < G__34967__a.length) {G__34967__a[G__34967__i] = arguments[G__34967__i + 13]; ++G__34967__i;}
  G__34281 = new cljs.core.IndexedSeq(G__34967__a,0,null);
} 
return sci$impl$fns$arity_13__delegate.call(this,G__34268,G__34269,G__34270,G__34271,G__34272,G__34273,G__34274,G__34275,G__34276,G__34277,G__34278,G__34279,G__34280,G__34281);};
sci$impl$fns$arity_13.cljs$lang$maxFixedArity = 13;
sci$impl$fns$arity_13.cljs$lang$applyTo = (function (arglist__34968){
var G__34268 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34269 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34270 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34271 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34272 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34273 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34274 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34275 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34276 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34277 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34278 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34279 = cljs.core.first(arglist__34968);
arglist__34968 = cljs.core.next(arglist__34968);
var G__34280 = cljs.core.first(arglist__34968);
var G__34281 = cljs.core.rest(arglist__34968);
return sci$impl$fns$arity_13__delegate(G__34268,G__34269,G__34270,G__34271,G__34272,G__34273,G__34274,G__34275,G__34276,G__34277,G__34278,G__34279,G__34280,G__34281);
});
sci$impl$fns$arity_13.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_13__delegate;
return sci$impl$fns$arity_13;
})()
;

break;
case (14):
return (function() { 
var sci$impl$fns$arity_14__delegate = function (G__34282,G__34283,G__34284,G__34285,G__34286,G__34287,G__34288,G__34289,G__34290,G__34291,G__34292,G__34293,G__34294,G__34295,G__34296){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34282);

(invoc_array[(1)] = G__34283);

(invoc_array[(2)] = G__34284);

(invoc_array[(3)] = G__34285);

(invoc_array[(4)] = G__34286);

(invoc_array[(5)] = G__34287);

(invoc_array[(6)] = G__34288);

(invoc_array[(7)] = G__34289);

(invoc_array[(8)] = G__34290);

(invoc_array[(9)] = G__34291);

(invoc_array[(10)] = G__34292);

(invoc_array[(11)] = G__34293);

(invoc_array[(12)] = G__34294);

(invoc_array[(13)] = G__34295);

(invoc_array[vararg_idx] = G__34296);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_14 = function (G__34282,G__34283,G__34284,G__34285,G__34286,G__34287,G__34288,G__34289,G__34290,G__34291,G__34292,G__34293,G__34294,G__34295,var_args){
var G__34296 = null;
if (arguments.length > 14) {
var G__34969__i = 0, G__34969__a = new Array(arguments.length -  14);
while (G__34969__i < G__34969__a.length) {G__34969__a[G__34969__i] = arguments[G__34969__i + 14]; ++G__34969__i;}
  G__34296 = new cljs.core.IndexedSeq(G__34969__a,0,null);
} 
return sci$impl$fns$arity_14__delegate.call(this,G__34282,G__34283,G__34284,G__34285,G__34286,G__34287,G__34288,G__34289,G__34290,G__34291,G__34292,G__34293,G__34294,G__34295,G__34296);};
sci$impl$fns$arity_14.cljs$lang$maxFixedArity = 14;
sci$impl$fns$arity_14.cljs$lang$applyTo = (function (arglist__34970){
var G__34282 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34283 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34284 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34285 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34286 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34287 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34288 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34289 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34290 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34291 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34292 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34293 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34294 = cljs.core.first(arglist__34970);
arglist__34970 = cljs.core.next(arglist__34970);
var G__34295 = cljs.core.first(arglist__34970);
var G__34296 = cljs.core.rest(arglist__34970);
return sci$impl$fns$arity_14__delegate(G__34282,G__34283,G__34284,G__34285,G__34286,G__34287,G__34288,G__34289,G__34290,G__34291,G__34292,G__34293,G__34294,G__34295,G__34296);
});
sci$impl$fns$arity_14.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_14__delegate;
return sci$impl$fns$arity_14;
})()
;

break;
case (15):
return (function() { 
var sci$impl$fns$arity_15__delegate = function (G__34297,G__34298,G__34299,G__34300,G__34301,G__34302,G__34303,G__34304,G__34305,G__34306,G__34307,G__34308,G__34309,G__34310,G__34311,G__34312){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34297);

(invoc_array[(1)] = G__34298);

(invoc_array[(2)] = G__34299);

(invoc_array[(3)] = G__34300);

(invoc_array[(4)] = G__34301);

(invoc_array[(5)] = G__34302);

(invoc_array[(6)] = G__34303);

(invoc_array[(7)] = G__34304);

(invoc_array[(8)] = G__34305);

(invoc_array[(9)] = G__34306);

(invoc_array[(10)] = G__34307);

(invoc_array[(11)] = G__34308);

(invoc_array[(12)] = G__34309);

(invoc_array[(13)] = G__34310);

(invoc_array[(14)] = G__34311);

(invoc_array[vararg_idx] = G__34312);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_15 = function (G__34297,G__34298,G__34299,G__34300,G__34301,G__34302,G__34303,G__34304,G__34305,G__34306,G__34307,G__34308,G__34309,G__34310,G__34311,var_args){
var G__34312 = null;
if (arguments.length > 15) {
var G__34971__i = 0, G__34971__a = new Array(arguments.length -  15);
while (G__34971__i < G__34971__a.length) {G__34971__a[G__34971__i] = arguments[G__34971__i + 15]; ++G__34971__i;}
  G__34312 = new cljs.core.IndexedSeq(G__34971__a,0,null);
} 
return sci$impl$fns$arity_15__delegate.call(this,G__34297,G__34298,G__34299,G__34300,G__34301,G__34302,G__34303,G__34304,G__34305,G__34306,G__34307,G__34308,G__34309,G__34310,G__34311,G__34312);};
sci$impl$fns$arity_15.cljs$lang$maxFixedArity = 15;
sci$impl$fns$arity_15.cljs$lang$applyTo = (function (arglist__34972){
var G__34297 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34298 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34299 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34300 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34301 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34302 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34303 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34304 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34305 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34306 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34307 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34308 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34309 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34310 = cljs.core.first(arglist__34972);
arglist__34972 = cljs.core.next(arglist__34972);
var G__34311 = cljs.core.first(arglist__34972);
var G__34312 = cljs.core.rest(arglist__34972);
return sci$impl$fns$arity_15__delegate(G__34297,G__34298,G__34299,G__34300,G__34301,G__34302,G__34303,G__34304,G__34305,G__34306,G__34307,G__34308,G__34309,G__34310,G__34311,G__34312);
});
sci$impl$fns$arity_15.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_15__delegate;
return sci$impl$fns$arity_15;
})()
;

break;
case (16):
return (function() { 
var sci$impl$fns$arity_16__delegate = function (G__34320,G__34321,G__34322,G__34323,G__34324,G__34325,G__34326,G__34327,G__34328,G__34329,G__34330,G__34331,G__34332,G__34333,G__34334,G__34335,G__34336){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34320);

(invoc_array[(1)] = G__34321);

(invoc_array[(2)] = G__34322);

(invoc_array[(3)] = G__34323);

(invoc_array[(4)] = G__34324);

(invoc_array[(5)] = G__34325);

(invoc_array[(6)] = G__34326);

(invoc_array[(7)] = G__34327);

(invoc_array[(8)] = G__34328);

(invoc_array[(9)] = G__34329);

(invoc_array[(10)] = G__34330);

(invoc_array[(11)] = G__34331);

(invoc_array[(12)] = G__34332);

(invoc_array[(13)] = G__34333);

(invoc_array[(14)] = G__34334);

(invoc_array[(15)] = G__34335);

(invoc_array[vararg_idx] = G__34336);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_16 = function (G__34320,G__34321,G__34322,G__34323,G__34324,G__34325,G__34326,G__34327,G__34328,G__34329,G__34330,G__34331,G__34332,G__34333,G__34334,G__34335,var_args){
var G__34336 = null;
if (arguments.length > 16) {
var G__34973__i = 0, G__34973__a = new Array(arguments.length -  16);
while (G__34973__i < G__34973__a.length) {G__34973__a[G__34973__i] = arguments[G__34973__i + 16]; ++G__34973__i;}
  G__34336 = new cljs.core.IndexedSeq(G__34973__a,0,null);
} 
return sci$impl$fns$arity_16__delegate.call(this,G__34320,G__34321,G__34322,G__34323,G__34324,G__34325,G__34326,G__34327,G__34328,G__34329,G__34330,G__34331,G__34332,G__34333,G__34334,G__34335,G__34336);};
sci$impl$fns$arity_16.cljs$lang$maxFixedArity = 16;
sci$impl$fns$arity_16.cljs$lang$applyTo = (function (arglist__34976){
var G__34320 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34321 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34322 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34323 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34324 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34325 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34326 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34327 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34328 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34329 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34330 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34331 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34332 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34333 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34334 = cljs.core.first(arglist__34976);
arglist__34976 = cljs.core.next(arglist__34976);
var G__34335 = cljs.core.first(arglist__34976);
var G__34336 = cljs.core.rest(arglist__34976);
return sci$impl$fns$arity_16__delegate(G__34320,G__34321,G__34322,G__34323,G__34324,G__34325,G__34326,G__34327,G__34328,G__34329,G__34330,G__34331,G__34332,G__34333,G__34334,G__34335,G__34336);
});
sci$impl$fns$arity_16.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_16__delegate;
return sci$impl$fns$arity_16;
})()
;

break;
case (17):
return (function() { 
var sci$impl$fns$arity_17__delegate = function (G__34353,G__34354,G__34355,G__34356,G__34357,G__34358,G__34359,G__34360,G__34361,G__34362,G__34363,G__34364,G__34365,G__34366,G__34367,G__34368,G__34369,G__34370){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34353);

(invoc_array[(1)] = G__34354);

(invoc_array[(2)] = G__34355);

(invoc_array[(3)] = G__34356);

(invoc_array[(4)] = G__34357);

(invoc_array[(5)] = G__34358);

(invoc_array[(6)] = G__34359);

(invoc_array[(7)] = G__34360);

(invoc_array[(8)] = G__34361);

(invoc_array[(9)] = G__34362);

(invoc_array[(10)] = G__34363);

(invoc_array[(11)] = G__34364);

(invoc_array[(12)] = G__34365);

(invoc_array[(13)] = G__34366);

(invoc_array[(14)] = G__34367);

(invoc_array[(15)] = G__34368);

(invoc_array[(16)] = G__34369);

(invoc_array[vararg_idx] = G__34370);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_17 = function (G__34353,G__34354,G__34355,G__34356,G__34357,G__34358,G__34359,G__34360,G__34361,G__34362,G__34363,G__34364,G__34365,G__34366,G__34367,G__34368,G__34369,var_args){
var G__34370 = null;
if (arguments.length > 17) {
var G__34979__i = 0, G__34979__a = new Array(arguments.length -  17);
while (G__34979__i < G__34979__a.length) {G__34979__a[G__34979__i] = arguments[G__34979__i + 17]; ++G__34979__i;}
  G__34370 = new cljs.core.IndexedSeq(G__34979__a,0,null);
} 
return sci$impl$fns$arity_17__delegate.call(this,G__34353,G__34354,G__34355,G__34356,G__34357,G__34358,G__34359,G__34360,G__34361,G__34362,G__34363,G__34364,G__34365,G__34366,G__34367,G__34368,G__34369,G__34370);};
sci$impl$fns$arity_17.cljs$lang$maxFixedArity = 17;
sci$impl$fns$arity_17.cljs$lang$applyTo = (function (arglist__34980){
var G__34353 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34354 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34355 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34356 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34357 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34358 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34359 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34360 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34361 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34362 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34363 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34364 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34365 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34366 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34367 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34368 = cljs.core.first(arglist__34980);
arglist__34980 = cljs.core.next(arglist__34980);
var G__34369 = cljs.core.first(arglist__34980);
var G__34370 = cljs.core.rest(arglist__34980);
return sci$impl$fns$arity_17__delegate(G__34353,G__34354,G__34355,G__34356,G__34357,G__34358,G__34359,G__34360,G__34361,G__34362,G__34363,G__34364,G__34365,G__34366,G__34367,G__34368,G__34369,G__34370);
});
sci$impl$fns$arity_17.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_17__delegate;
return sci$impl$fns$arity_17;
})()
;

break;
case (18):
return (function() { 
var sci$impl$fns$arity_18__delegate = function (G__34371,G__34372,G__34373,G__34374,G__34375,G__34376,G__34377,G__34378,G__34379,G__34380,G__34381,G__34382,G__34383,G__34384,G__34385,G__34386,G__34387,G__34388,G__34389){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34371);

(invoc_array[(1)] = G__34372);

(invoc_array[(2)] = G__34373);

(invoc_array[(3)] = G__34374);

(invoc_array[(4)] = G__34375);

(invoc_array[(5)] = G__34376);

(invoc_array[(6)] = G__34377);

(invoc_array[(7)] = G__34378);

(invoc_array[(8)] = G__34379);

(invoc_array[(9)] = G__34380);

(invoc_array[(10)] = G__34381);

(invoc_array[(11)] = G__34382);

(invoc_array[(12)] = G__34383);

(invoc_array[(13)] = G__34384);

(invoc_array[(14)] = G__34385);

(invoc_array[(15)] = G__34386);

(invoc_array[(16)] = G__34387);

(invoc_array[(17)] = G__34388);

(invoc_array[vararg_idx] = G__34389);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_18 = function (G__34371,G__34372,G__34373,G__34374,G__34375,G__34376,G__34377,G__34378,G__34379,G__34380,G__34381,G__34382,G__34383,G__34384,G__34385,G__34386,G__34387,G__34388,var_args){
var G__34389 = null;
if (arguments.length > 18) {
var G__34981__i = 0, G__34981__a = new Array(arguments.length -  18);
while (G__34981__i < G__34981__a.length) {G__34981__a[G__34981__i] = arguments[G__34981__i + 18]; ++G__34981__i;}
  G__34389 = new cljs.core.IndexedSeq(G__34981__a,0,null);
} 
return sci$impl$fns$arity_18__delegate.call(this,G__34371,G__34372,G__34373,G__34374,G__34375,G__34376,G__34377,G__34378,G__34379,G__34380,G__34381,G__34382,G__34383,G__34384,G__34385,G__34386,G__34387,G__34388,G__34389);};
sci$impl$fns$arity_18.cljs$lang$maxFixedArity = 18;
sci$impl$fns$arity_18.cljs$lang$applyTo = (function (arglist__34982){
var G__34371 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34372 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34373 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34374 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34375 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34376 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34377 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34378 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34379 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34380 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34381 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34382 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34383 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34384 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34385 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34386 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34387 = cljs.core.first(arglist__34982);
arglist__34982 = cljs.core.next(arglist__34982);
var G__34388 = cljs.core.first(arglist__34982);
var G__34389 = cljs.core.rest(arglist__34982);
return sci$impl$fns$arity_18__delegate(G__34371,G__34372,G__34373,G__34374,G__34375,G__34376,G__34377,G__34378,G__34379,G__34380,G__34381,G__34382,G__34383,G__34384,G__34385,G__34386,G__34387,G__34388,G__34389);
});
sci$impl$fns$arity_18.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_18__delegate;
return sci$impl$fns$arity_18;
})()
;

break;
case (19):
return (function() { 
var sci$impl$fns$arity_19__delegate = function (G__34398,G__34399,G__34400,G__34401,G__34402,G__34403,G__34404,G__34405,G__34406,G__34407,G__34408,G__34409,G__34410,G__34411,G__34412,G__34413,G__34414,G__34415,G__34416,G__34417){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34398);

(invoc_array[(1)] = G__34399);

(invoc_array[(2)] = G__34400);

(invoc_array[(3)] = G__34401);

(invoc_array[(4)] = G__34402);

(invoc_array[(5)] = G__34403);

(invoc_array[(6)] = G__34404);

(invoc_array[(7)] = G__34405);

(invoc_array[(8)] = G__34406);

(invoc_array[(9)] = G__34407);

(invoc_array[(10)] = G__34408);

(invoc_array[(11)] = G__34409);

(invoc_array[(12)] = G__34410);

(invoc_array[(13)] = G__34411);

(invoc_array[(14)] = G__34412);

(invoc_array[(15)] = G__34413);

(invoc_array[(16)] = G__34414);

(invoc_array[(17)] = G__34415);

(invoc_array[(18)] = G__34416);

(invoc_array[vararg_idx] = G__34417);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_19 = function (G__34398,G__34399,G__34400,G__34401,G__34402,G__34403,G__34404,G__34405,G__34406,G__34407,G__34408,G__34409,G__34410,G__34411,G__34412,G__34413,G__34414,G__34415,G__34416,var_args){
var G__34417 = null;
if (arguments.length > 19) {
var G__34983__i = 0, G__34983__a = new Array(arguments.length -  19);
while (G__34983__i < G__34983__a.length) {G__34983__a[G__34983__i] = arguments[G__34983__i + 19]; ++G__34983__i;}
  G__34417 = new cljs.core.IndexedSeq(G__34983__a,0,null);
} 
return sci$impl$fns$arity_19__delegate.call(this,G__34398,G__34399,G__34400,G__34401,G__34402,G__34403,G__34404,G__34405,G__34406,G__34407,G__34408,G__34409,G__34410,G__34411,G__34412,G__34413,G__34414,G__34415,G__34416,G__34417);};
sci$impl$fns$arity_19.cljs$lang$maxFixedArity = 19;
sci$impl$fns$arity_19.cljs$lang$applyTo = (function (arglist__34984){
var G__34398 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34399 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34400 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34401 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34402 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34403 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34404 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34405 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34406 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34407 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34408 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34409 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34410 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34411 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34412 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34413 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34414 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34415 = cljs.core.first(arglist__34984);
arglist__34984 = cljs.core.next(arglist__34984);
var G__34416 = cljs.core.first(arglist__34984);
var G__34417 = cljs.core.rest(arglist__34984);
return sci$impl$fns$arity_19__delegate(G__34398,G__34399,G__34400,G__34401,G__34402,G__34403,G__34404,G__34405,G__34406,G__34407,G__34408,G__34409,G__34410,G__34411,G__34412,G__34413,G__34414,G__34415,G__34416,G__34417);
});
sci$impl$fns$arity_19.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_19__delegate;
return sci$impl$fns$arity_19;
})()
;

break;
case (20):
return (function() { 
var sci$impl$fns$arity_20__delegate = function (G__34429,G__34430,G__34431,G__34432,G__34433,G__34434,G__34435,G__34436,G__34437,G__34438,G__34439,G__34440,G__34441,G__34442,G__34443,G__34444,G__34445,G__34446,G__34447,G__34448,G__34449){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34429);

(invoc_array[(1)] = G__34430);

(invoc_array[(2)] = G__34431);

(invoc_array[(3)] = G__34432);

(invoc_array[(4)] = G__34433);

(invoc_array[(5)] = G__34434);

(invoc_array[(6)] = G__34435);

(invoc_array[(7)] = G__34436);

(invoc_array[(8)] = G__34437);

(invoc_array[(9)] = G__34438);

(invoc_array[(10)] = G__34439);

(invoc_array[(11)] = G__34440);

(invoc_array[(12)] = G__34441);

(invoc_array[(13)] = G__34442);

(invoc_array[(14)] = G__34443);

(invoc_array[(15)] = G__34444);

(invoc_array[(16)] = G__34445);

(invoc_array[(17)] = G__34446);

(invoc_array[(18)] = G__34447);

(invoc_array[(19)] = G__34448);

(invoc_array[vararg_idx] = G__34449);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
};
var sci$impl$fns$arity_20 = function (G__34429,G__34430,G__34431,G__34432,G__34433,G__34434,G__34435,G__34436,G__34437,G__34438,G__34439,G__34440,G__34441,G__34442,G__34443,G__34444,G__34445,G__34446,G__34447,G__34448,var_args){
var G__34449 = null;
if (arguments.length > 20) {
var G__35006__i = 0, G__35006__a = new Array(arguments.length -  20);
while (G__35006__i < G__35006__a.length) {G__35006__a[G__35006__i] = arguments[G__35006__i + 20]; ++G__35006__i;}
  G__34449 = new cljs.core.IndexedSeq(G__35006__a,0,null);
} 
return sci$impl$fns$arity_20__delegate.call(this,G__34429,G__34430,G__34431,G__34432,G__34433,G__34434,G__34435,G__34436,G__34437,G__34438,G__34439,G__34440,G__34441,G__34442,G__34443,G__34444,G__34445,G__34446,G__34447,G__34448,G__34449);};
sci$impl$fns$arity_20.cljs$lang$maxFixedArity = 20;
sci$impl$fns$arity_20.cljs$lang$applyTo = (function (arglist__35007){
var G__34429 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34430 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34431 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34432 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34433 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34434 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34435 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34436 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34437 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34438 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34439 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34440 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34441 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34442 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34443 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34444 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34445 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34446 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34447 = cljs.core.first(arglist__35007);
arglist__35007 = cljs.core.next(arglist__35007);
var G__34448 = cljs.core.first(arglist__35007);
var G__34449 = cljs.core.rest(arglist__35007);
return sci$impl$fns$arity_20__delegate(G__34429,G__34430,G__34431,G__34432,G__34433,G__34434,G__34435,G__34436,G__34437,G__34438,G__34439,G__34440,G__34441,G__34442,G__34443,G__34444,G__34445,G__34446,G__34447,G__34448,G__34449);
});
sci$impl$fns$arity_20.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$arity_20__delegate;
return sci$impl$fns$arity_20;
})()
;

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__34143)].join('')));

}
})():(function (){var G__34453 = fixed_arity;
switch (G__34453) {
case (0):
return (function sci$impl$fns$arity_0(){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

while(true){
var ret__33493__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33493__auto__)){
continue;
} else {
return ret__33493__auto__;
}
break;
}
});

break;
case (1):
return (function sci$impl$fns$arity_1(G__34461){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34461);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (2):
return (function sci$impl$fns$arity_2(G__34462,G__34463){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34462);

(invoc_array[(1)] = G__34463);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (3):
return (function sci$impl$fns$arity_3(G__34474,G__34475,G__34476){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34474);

(invoc_array[(1)] = G__34475);

(invoc_array[(2)] = G__34476);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (4):
return (function sci$impl$fns$arity_4(G__34477,G__34478,G__34479,G__34480){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34477);

(invoc_array[(1)] = G__34478);

(invoc_array[(2)] = G__34479);

(invoc_array[(3)] = G__34480);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (5):
return (function sci$impl$fns$arity_5(G__34484,G__34485,G__34486,G__34487,G__34488){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34484);

(invoc_array[(1)] = G__34485);

(invoc_array[(2)] = G__34486);

(invoc_array[(3)] = G__34487);

(invoc_array[(4)] = G__34488);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (6):
return (function sci$impl$fns$arity_6(G__34496,G__34497,G__34498,G__34499,G__34500,G__34501){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34496);

(invoc_array[(1)] = G__34497);

(invoc_array[(2)] = G__34498);

(invoc_array[(3)] = G__34499);

(invoc_array[(4)] = G__34500);

(invoc_array[(5)] = G__34501);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (7):
return (function sci$impl$fns$arity_7(G__34502,G__34503,G__34504,G__34505,G__34506,G__34507,G__34508){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34502);

(invoc_array[(1)] = G__34503);

(invoc_array[(2)] = G__34504);

(invoc_array[(3)] = G__34505);

(invoc_array[(4)] = G__34506);

(invoc_array[(5)] = G__34507);

(invoc_array[(6)] = G__34508);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (8):
return (function sci$impl$fns$arity_8(G__34512,G__34513,G__34514,G__34515,G__34516,G__34517,G__34518,G__34519){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34512);

(invoc_array[(1)] = G__34513);

(invoc_array[(2)] = G__34514);

(invoc_array[(3)] = G__34515);

(invoc_array[(4)] = G__34516);

(invoc_array[(5)] = G__34517);

(invoc_array[(6)] = G__34518);

(invoc_array[(7)] = G__34519);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (9):
return (function sci$impl$fns$arity_9(G__34527,G__34528,G__34529,G__34530,G__34531,G__34532,G__34533,G__34534,G__34535){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34527);

(invoc_array[(1)] = G__34528);

(invoc_array[(2)] = G__34529);

(invoc_array[(3)] = G__34530);

(invoc_array[(4)] = G__34531);

(invoc_array[(5)] = G__34532);

(invoc_array[(6)] = G__34533);

(invoc_array[(7)] = G__34534);

(invoc_array[(8)] = G__34535);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (10):
return (function sci$impl$fns$arity_10(G__34539,G__34540,G__34541,G__34542,G__34543,G__34544,G__34545,G__34546,G__34547,G__34548){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34539);

(invoc_array[(1)] = G__34540);

(invoc_array[(2)] = G__34541);

(invoc_array[(3)] = G__34542);

(invoc_array[(4)] = G__34543);

(invoc_array[(5)] = G__34544);

(invoc_array[(6)] = G__34545);

(invoc_array[(7)] = G__34546);

(invoc_array[(8)] = G__34547);

(invoc_array[(9)] = G__34548);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (11):
return (function sci$impl$fns$arity_11(G__34549,G__34550,G__34551,G__34552,G__34553,G__34554,G__34555,G__34556,G__34557,G__34558,G__34559){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34549);

(invoc_array[(1)] = G__34550);

(invoc_array[(2)] = G__34551);

(invoc_array[(3)] = G__34552);

(invoc_array[(4)] = G__34553);

(invoc_array[(5)] = G__34554);

(invoc_array[(6)] = G__34555);

(invoc_array[(7)] = G__34556);

(invoc_array[(8)] = G__34557);

(invoc_array[(9)] = G__34558);

(invoc_array[(10)] = G__34559);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (12):
return (function sci$impl$fns$arity_12(G__34572,G__34573,G__34574,G__34575,G__34576,G__34577,G__34578,G__34579,G__34580,G__34581,G__34582,G__34583){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34572);

(invoc_array[(1)] = G__34573);

(invoc_array[(2)] = G__34574);

(invoc_array[(3)] = G__34575);

(invoc_array[(4)] = G__34576);

(invoc_array[(5)] = G__34577);

(invoc_array[(6)] = G__34578);

(invoc_array[(7)] = G__34579);

(invoc_array[(8)] = G__34580);

(invoc_array[(9)] = G__34581);

(invoc_array[(10)] = G__34582);

(invoc_array[(11)] = G__34583);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (13):
return (function sci$impl$fns$arity_13(G__34584,G__34585,G__34586,G__34587,G__34588,G__34589,G__34590,G__34591,G__34592,G__34593,G__34594,G__34595,G__34596){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34584);

(invoc_array[(1)] = G__34585);

(invoc_array[(2)] = G__34586);

(invoc_array[(3)] = G__34587);

(invoc_array[(4)] = G__34588);

(invoc_array[(5)] = G__34589);

(invoc_array[(6)] = G__34590);

(invoc_array[(7)] = G__34591);

(invoc_array[(8)] = G__34592);

(invoc_array[(9)] = G__34593);

(invoc_array[(10)] = G__34594);

(invoc_array[(11)] = G__34595);

(invoc_array[(12)] = G__34596);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (14):
return (function sci$impl$fns$arity_14(G__34602,G__34603,G__34604,G__34605,G__34606,G__34607,G__34608,G__34609,G__34610,G__34611,G__34612,G__34613,G__34614,G__34615){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34602);

(invoc_array[(1)] = G__34603);

(invoc_array[(2)] = G__34604);

(invoc_array[(3)] = G__34605);

(invoc_array[(4)] = G__34606);

(invoc_array[(5)] = G__34607);

(invoc_array[(6)] = G__34608);

(invoc_array[(7)] = G__34609);

(invoc_array[(8)] = G__34610);

(invoc_array[(9)] = G__34611);

(invoc_array[(10)] = G__34612);

(invoc_array[(11)] = G__34613);

(invoc_array[(12)] = G__34614);

(invoc_array[(13)] = G__34615);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (15):
return (function sci$impl$fns$arity_15(G__34619,G__34620,G__34621,G__34622,G__34623,G__34624,G__34625,G__34626,G__34627,G__34628,G__34629,G__34630,G__34631,G__34632,G__34633){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34619);

(invoc_array[(1)] = G__34620);

(invoc_array[(2)] = G__34621);

(invoc_array[(3)] = G__34622);

(invoc_array[(4)] = G__34623);

(invoc_array[(5)] = G__34624);

(invoc_array[(6)] = G__34625);

(invoc_array[(7)] = G__34626);

(invoc_array[(8)] = G__34627);

(invoc_array[(9)] = G__34628);

(invoc_array[(10)] = G__34629);

(invoc_array[(11)] = G__34630);

(invoc_array[(12)] = G__34631);

(invoc_array[(13)] = G__34632);

(invoc_array[(14)] = G__34633);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (16):
return (function sci$impl$fns$arity_16(G__34638,G__34639,G__34640,G__34641,G__34642,G__34643,G__34644,G__34645,G__34646,G__34647,G__34648,G__34649,G__34650,G__34651,G__34652,G__34653){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34638);

(invoc_array[(1)] = G__34639);

(invoc_array[(2)] = G__34640);

(invoc_array[(3)] = G__34641);

(invoc_array[(4)] = G__34642);

(invoc_array[(5)] = G__34643);

(invoc_array[(6)] = G__34644);

(invoc_array[(7)] = G__34645);

(invoc_array[(8)] = G__34646);

(invoc_array[(9)] = G__34647);

(invoc_array[(10)] = G__34648);

(invoc_array[(11)] = G__34649);

(invoc_array[(12)] = G__34650);

(invoc_array[(13)] = G__34651);

(invoc_array[(14)] = G__34652);

(invoc_array[(15)] = G__34653);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (17):
return (function sci$impl$fns$arity_17(G__34654,G__34655,G__34656,G__34657,G__34658,G__34659,G__34660,G__34661,G__34662,G__34663,G__34664,G__34665,G__34666,G__34667,G__34668,G__34669,G__34670){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34654);

(invoc_array[(1)] = G__34655);

(invoc_array[(2)] = G__34656);

(invoc_array[(3)] = G__34657);

(invoc_array[(4)] = G__34658);

(invoc_array[(5)] = G__34659);

(invoc_array[(6)] = G__34660);

(invoc_array[(7)] = G__34661);

(invoc_array[(8)] = G__34662);

(invoc_array[(9)] = G__34663);

(invoc_array[(10)] = G__34664);

(invoc_array[(11)] = G__34665);

(invoc_array[(12)] = G__34666);

(invoc_array[(13)] = G__34667);

(invoc_array[(14)] = G__34668);

(invoc_array[(15)] = G__34669);

(invoc_array[(16)] = G__34670);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (18):
return (function sci$impl$fns$arity_18(G__34678,G__34679,G__34680,G__34681,G__34682,G__34683,G__34684,G__34685,G__34686,G__34687,G__34688,G__34689,G__34690,G__34691,G__34692,G__34693,G__34694,G__34695){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34678);

(invoc_array[(1)] = G__34679);

(invoc_array[(2)] = G__34680);

(invoc_array[(3)] = G__34681);

(invoc_array[(4)] = G__34682);

(invoc_array[(5)] = G__34683);

(invoc_array[(6)] = G__34684);

(invoc_array[(7)] = G__34685);

(invoc_array[(8)] = G__34686);

(invoc_array[(9)] = G__34687);

(invoc_array[(10)] = G__34688);

(invoc_array[(11)] = G__34689);

(invoc_array[(12)] = G__34690);

(invoc_array[(13)] = G__34691);

(invoc_array[(14)] = G__34692);

(invoc_array[(15)] = G__34693);

(invoc_array[(16)] = G__34694);

(invoc_array[(17)] = G__34695);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (19):
return (function sci$impl$fns$arity_19(G__34696,G__34697,G__34698,G__34699,G__34700,G__34701,G__34702,G__34703,G__34704,G__34705,G__34706,G__34707,G__34708,G__34709,G__34710,G__34711,G__34712,G__34713,G__34714){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34696);

(invoc_array[(1)] = G__34697);

(invoc_array[(2)] = G__34698);

(invoc_array[(3)] = G__34699);

(invoc_array[(4)] = G__34700);

(invoc_array[(5)] = G__34701);

(invoc_array[(6)] = G__34702);

(invoc_array[(7)] = G__34703);

(invoc_array[(8)] = G__34704);

(invoc_array[(9)] = G__34705);

(invoc_array[(10)] = G__34706);

(invoc_array[(11)] = G__34707);

(invoc_array[(12)] = G__34708);

(invoc_array[(13)] = G__34709);

(invoc_array[(14)] = G__34710);

(invoc_array[(15)] = G__34711);

(invoc_array[(16)] = G__34712);

(invoc_array[(17)] = G__34713);

(invoc_array[(18)] = G__34714);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
case (20):
return (function sci$impl$fns$arity_20(G__34725,G__34726,G__34727,G__34728,G__34729,G__34730,G__34731,G__34732,G__34733,G__34734,G__34735,G__34736,G__34737,G__34738,G__34739,G__34740,G__34741,G__34742,G__34743,G__34744){
var invoc_array = (((invoc_size === (0)))?null:cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(invoc_size));
if(cljs.core.truth_(enclosed__GT_invocation)){
(enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2 ? enclosed__GT_invocation.cljs$core$IFn$_invoke$arity$2(enclosed_array,invoc_array) : enclosed__GT_invocation.call(null,enclosed_array,invoc_array));
} else {
}

(invoc_array[(0)] = G__34725);

(invoc_array[(1)] = G__34726);

(invoc_array[(2)] = G__34727);

(invoc_array[(3)] = G__34728);

(invoc_array[(4)] = G__34729);

(invoc_array[(5)] = G__34730);

(invoc_array[(6)] = G__34731);

(invoc_array[(7)] = G__34732);

(invoc_array[(8)] = G__34733);

(invoc_array[(9)] = G__34734);

(invoc_array[(10)] = G__34735);

(invoc_array[(11)] = G__34736);

(invoc_array[(12)] = G__34737);

(invoc_array[(13)] = G__34738);

(invoc_array[(14)] = G__34739);

(invoc_array[(15)] = G__34740);

(invoc_array[(16)] = G__34741);

(invoc_array[(17)] = G__34742);

(invoc_array[(18)] = G__34743);

(invoc_array[(19)] = G__34744);

while(true){
var ret__33494__auto__ = sci.impl.types.eval(body,ctx,invoc_array);
if(cljs.core.keyword_identical_QMARK_(new cljs.core.Keyword("sci.impl.analyzer","recur","sci.impl.analyzer/recur",2033369355),ret__33494__auto__)){
continue;
} else {
return ret__33494__auto__;
}
break;
}
});

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__34453)].join('')));

}
})());
return f;
}));

(sci.impl.fns.fun.cljs$lang$maxFixedArity = 11);

sci.impl.fns.lookup_by_arity = (function sci$impl$fns$lookup_by_arity(arities,arity){
var or__5045__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(arities,arity);
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(arities);
}
});
sci.impl.fns.fn_arity_map = (function sci$impl$fns$fn_arity_map(ctx,enclosed_array,fn_name,macro_QMARK_,fn_bodies){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (arity_map,fn_body){
var f = sci.impl.fns.fun.cljs$core$IFn$_invoke$arity$5(ctx,enclosed_array,fn_body,fn_name,macro_QMARK_);
var var_arg_QMARK_ = new cljs.core.Keyword(null,"var-arg-name","var-arg-name",-1100024887).cljs$core$IFn$_invoke$arity$1(fn_body);
var fixed_arity = new cljs.core.Keyword(null,"fixed-arity","fixed-arity",1586445869).cljs$core$IFn$_invoke$arity$1(fn_body);
if(cljs.core.truth_(var_arg_QMARK_)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(arity_map,new cljs.core.Keyword(null,"variadic","variadic",882626057),f);
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(arity_map,fixed_arity,f);
}
}),cljs.core.PersistentArrayMap.EMPTY,fn_bodies);
});
sci.impl.fns.maybe_destructured = (function sci$impl$fns$maybe_destructured(params,body){
if(cljs.core.every_QMARK_(cljs.core.symbol_QMARK_,params)){
return cljs.core.cons(params,body);
} else {
var params__$1 = params;
var new_params = cljs.core.with_meta(cljs.core.PersistentVector.EMPTY,cljs.core.meta(params__$1));
var lets = cljs.core.PersistentVector.EMPTY;
while(true){
if(cljs.core.truth_(params__$1)){
if((cljs.core.first(params__$1) instanceof cljs.core.Symbol)){
var G__35127 = cljs.core.next(params__$1);
var G__35128 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(new_params,cljs.core.first(params__$1));
var G__35129 = lets;
params__$1 = G__35127;
new_params = G__35128;
lets = G__35129;
continue;
} else {
var gparam = cljs.core.gensym.cljs$core$IFn$_invoke$arity$1("p__");
var G__35130 = cljs.core.next(params__$1);
var G__35131 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(new_params,gparam);
var G__35132 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.conj.cljs$core$IFn$_invoke$arity$2(lets,cljs.core.first(params__$1)),gparam);
params__$1 = G__35130;
new_params = G__35131;
lets = G__35132;
continue;
}
} else {
return cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new_params,null,(1),null)),(new cljs.core.List(null,cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$variadic((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","let","cljs.core/let",-308701135,null),null,(1),null)),(new cljs.core.List(null,lets,null,(1),null)),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([body], 0)))),null,(1),null)))));
}
break;
}
}
});
sci.impl.fns.fn_STAR__STAR_ = (function sci$impl$fns$fn_STAR__STAR_(var_args){
var args__5775__auto__ = [];
var len__5769__auto___35134 = arguments.length;
var i__5770__auto___35135 = (0);
while(true){
if((i__5770__auto___35135 < len__5769__auto___35134)){
args__5775__auto__.push((arguments[i__5770__auto___35135]));

var G__35139 = (i__5770__auto___35135 + (1));
i__5770__auto___35135 = G__35139;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((2) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((2)),(0),null)):null);
return sci.impl.fns.fn_STAR__STAR_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__5776__auto__);
});

(sci.impl.fns.fn_STAR__STAR_.cljs$core$IFn$_invoke$arity$variadic = (function (form,_,sigs){
var name = (((cljs.core.first(sigs) instanceof cljs.core.Symbol))?cljs.core.first(sigs):null);
var sigs__$1 = (cljs.core.truth_(name)?cljs.core.next(sigs):sigs);
var sigs__$2 = ((cljs.core.vector_QMARK_(cljs.core.first(sigs__$1)))?(new cljs.core.List(null,sigs__$1,null,(1),null)):((cljs.core.seq_QMARK_(cljs.core.first(sigs__$1)))?sigs__$1:sci.impl.utils.throw_error_with_location.cljs$core$IFn$_invoke$arity$2(((cljs.core.seq(sigs__$1))?["Parameter declaration ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.first(sigs__$1))," should be a vector"].join(''):"Parameter declaration missing"),form)));
var psig = (function (sig){
if((!(cljs.core.seq_QMARK_(sig)))){
throw sci.impl.utils.throw_error_with_location.cljs$core$IFn$_invoke$arity$2(["Invalid signature ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(sig)," should be a list"].join(''),form);
} else {
}

var vec__34775 = sig;
var seq__34776 = cljs.core.seq(vec__34775);
var first__34777 = cljs.core.first(seq__34776);
var seq__34776__$1 = cljs.core.next(seq__34776);
var params = first__34777;
var body = seq__34776__$1;
var ___$1 = (((!(cljs.core.vector_QMARK_(params))))?sci.impl.utils.throw_error_with_location.cljs$core$IFn$_invoke$arity$2(((cljs.core.seq_QMARK_(cljs.core.first(sigs__$2)))?["Parameter declaration ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(params)," should be a vector"].join(''):["Invalid signature ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(sig)," should be a list"].join('')),form):null);
var conds = ((((cljs.core.next(body)) && (cljs.core.map_QMARK_(cljs.core.first(body)))))?cljs.core.first(body):null);
var body__$1 = (cljs.core.truth_(conds)?cljs.core.next(body):body);
var conds__$1 = (function (){var or__5045__auto__ = conds;
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return cljs.core.meta(params);
}
})();
var pre = new cljs.core.Keyword(null,"pre","pre",2118456869).cljs$core$IFn$_invoke$arity$1(conds__$1);
var post = new cljs.core.Keyword(null,"post","post",269697687).cljs$core$IFn$_invoke$arity$1(conds__$1);
var body__$2 = (cljs.core.truth_(post)?cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$1((new cljs.core.List(null,cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$variadic((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","let","cljs.core/let",-308701135,null),null,(1),null)),(new cljs.core.List(null,cljs.core.vec(cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new cljs.core.Symbol(null,"%","%",-950237169,null),null,(1),null)),(new cljs.core.List(null,((((1) < cljs.core.count(body__$1)))?cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new cljs.core.Symbol(null,"do","do",1686842252,null),null,(1),null)),body__$1))):cljs.core.first(body__$1)),null,(1),null)))))),null,(1),null)),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (c){
return cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","assert","cljs.core/assert",1075777968,null),null,(1),null)),(new cljs.core.List(null,c,null,(1),null)))));
}),post),(new cljs.core.List(null,new cljs.core.Symbol(null,"%","%",-950237169,null),null,(1),null))], 0)))),null,(1),null))))):body__$1);
var body__$3 = (cljs.core.truth_(pre)?cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (c){
return cljs.core.sequence.cljs$core$IFn$_invoke$arity$1(cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.List(null,new cljs.core.Symbol("cljs.core","assert","cljs.core/assert",1075777968,null),null,(1),null)),(new cljs.core.List(null,c,null,(1),null)))));
}),pre),body__$2):body__$2);
return sci.impl.fns.maybe_destructured(params,body__$3);
});
var new_sigs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(psig,sigs__$2);
var expr = cljs.core.with_meta((cljs.core.truth_(name)?cljs.core.list_STAR_.cljs$core$IFn$_invoke$arity$3(new cljs.core.Symbol(null,"fn*","fn*",-752876845,null),name,new_sigs):cljs.core.cons(new cljs.core.Symbol(null,"fn*","fn*",-752876845,null),new_sigs)),cljs.core.meta(form));
return expr;
}));

(sci.impl.fns.fn_STAR__STAR_.cljs$lang$maxFixedArity = (2));

/** @this {Function} */
(sci.impl.fns.fn_STAR__STAR_.cljs$lang$applyTo = (function (seq34757){
var G__34758 = cljs.core.first(seq34757);
var seq34757__$1 = cljs.core.next(seq34757);
var G__34759 = cljs.core.first(seq34757__$1);
var seq34757__$2 = cljs.core.next(seq34757__$1);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__34758,G__34759,seq34757__$2);
}));

sci.impl.fns.sigs = (function sci$impl$fns$sigs(fdecl){
var asig = (function (fdecl__$1){
var arglist = cljs.core.first(fdecl__$1);
var arglist__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Symbol(null,"&form","&form",1482799337,null),cljs.core.first(arglist)))?cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(arglist,(2),cljs.core.count(arglist)):arglist);
var body = cljs.core.next(fdecl__$1);
if(cljs.core.map_QMARK_(cljs.core.first(body))){
if(cljs.core.next(body)){
return cljs.core.with_meta(arglist__$1,cljs.core.conj.cljs$core$IFn$_invoke$arity$2((cljs.core.truth_(cljs.core.meta(arglist__$1))?cljs.core.meta(arglist__$1):cljs.core.PersistentArrayMap.EMPTY),cljs.core.first(body)));
} else {
return arglist__$1;
}
} else {
return arglist__$1;
}
});
if(cljs.core.seq_QMARK_(cljs.core.first(fdecl))){
var ret = cljs.core.PersistentVector.EMPTY;
var fdecls = fdecl;
while(true){
if(cljs.core.truth_(fdecls)){
var G__35140 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,cljs.core.identity(asig(cljs.core.first(fdecls))));
var G__35141 = cljs.core.next(fdecls);
ret = G__35140;
fdecls = G__35141;
continue;
} else {
return cljs.core.seq(ret);
}
break;
}
} else {
return (new cljs.core.List(null,cljs.core.identity(asig(fdecl)),null,(1),null));
}
});
sci.impl.fns.defn_STAR_ = (function sci$impl$fns$defn_STAR_(var_args){
var args__5775__auto__ = [];
var len__5769__auto___35142 = arguments.length;
var i__5770__auto___35143 = (0);
while(true){
if((i__5770__auto___35143 < len__5769__auto___35142)){
args__5775__auto__.push((arguments[i__5770__auto___35143]));

var G__35144 = (i__5770__auto___35143 + (1));
i__5770__auto___35143 = G__35144;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((3) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((3)),(0),null)):null);
return sci.impl.fns.defn_STAR_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5776__auto__);
});

(sci.impl.fns.defn_STAR_.cljs$core$IFn$_invoke$arity$variadic = (function (form,_,name,fdecl){
if((name instanceof cljs.core.Symbol)){
} else {
sci.impl.utils.throw_error_with_location.cljs$core$IFn$_invoke$arity$2("First argument to defn must be a symbol",form);
}

var m = ((typeof cljs.core.first(fdecl) === 'string')?new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"doc","doc",1913296891),cljs.core.first(fdecl)], null):cljs.core.PersistentArrayMap.EMPTY);
var fdecl__$1 = ((typeof cljs.core.first(fdecl) === 'string')?cljs.core.next(fdecl):fdecl);
var m__$1 = ((cljs.core.map_QMARK_(cljs.core.first(fdecl__$1)))?cljs.core.conj.cljs$core$IFn$_invoke$arity$2(m,cljs.core.first(fdecl__$1)):m);
var fdecl__$2 = ((cljs.core.map_QMARK_(cljs.core.first(fdecl__$1)))?cljs.core.next(fdecl__$1):fdecl__$1);
var fdecl__$3 = ((cljs.core.vector_QMARK_(cljs.core.first(fdecl__$2)))?(new cljs.core.List(null,fdecl__$2,null,(1),null)):fdecl__$2);
var m__$2 = ((cljs.core.map_QMARK_(cljs.core.last(fdecl__$3)))?cljs.core.conj.cljs$core$IFn$_invoke$arity$2(m__$1,cljs.core.last(fdecl__$3)):m__$1);
var fdecl__$4 = ((cljs.core.map_QMARK_(cljs.core.last(fdecl__$3)))?cljs.core.butlast(fdecl__$3):fdecl__$3);
var m__$3 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),(new cljs.core.List(null,new cljs.core.Symbol(null,"quote","quote",1377916282,null),(new cljs.core.List(null,sci.impl.fns.sigs(fdecl__$4),null,(1),null)),(2),null))], null),m__$2);
var name_m = cljs.core.meta(name);
var m__$4 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2((cljs.core.truth_(name_m)?name_m:cljs.core.PersistentArrayMap.EMPTY),m__$3);
var macro_QMARK_ = new cljs.core.Keyword(null,"macro","macro",-867863404).cljs$core$IFn$_invoke$arity$1(name_m);
var expr = cljs.core.cons(new cljs.core.Symbol("cljs.core","fn","cljs.core/fn",-1065745098,null),fdecl__$4);
var expr__$1 = (new cljs.core.List(null,new cljs.core.Symbol(null,"def","def",597100991,null),(new cljs.core.List(null,cljs.core.with_meta(name,m__$4),(new cljs.core.List(null,(cljs.core.truth_((function (){var or__5045__auto__ = macro_QMARK_;
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return name;
}
})())?cljs.core.with_meta(expr,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword("sci.impl","fn","sci.impl/fn",1695180073),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"macro","macro",-867863404),macro_QMARK_,new cljs.core.Keyword(null,"fn-name","fn-name",-766594004),name], null)], null)):expr),null,(1),null)),(2),null)),(3),null));
return expr__$1;
}));

(sci.impl.fns.defn_STAR_.cljs$lang$maxFixedArity = (3));

/** @this {Function} */
(sci.impl.fns.defn_STAR_.cljs$lang$applyTo = (function (seq34826){
var G__34827 = cljs.core.first(seq34826);
var seq34826__$1 = cljs.core.next(seq34826);
var G__34828 = cljs.core.first(seq34826__$1);
var seq34826__$2 = cljs.core.next(seq34826__$1);
var G__34829 = cljs.core.first(seq34826__$2);
var seq34826__$3 = cljs.core.next(seq34826__$2);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__34827,G__34828,G__34829,seq34826__$3);
}));

sci.impl.fns.defmacro_STAR_ = (function sci$impl$fns$defmacro_STAR_(var_args){
var args__5775__auto__ = [];
var len__5769__auto___35145 = arguments.length;
var i__5770__auto___35146 = (0);
while(true){
if((i__5770__auto___35146 < len__5769__auto___35145)){
args__5775__auto__.push((arguments[i__5770__auto___35146]));

var G__35147 = (i__5770__auto___35146 + (1));
i__5770__auto___35146 = G__35147;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((3) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((3)),(0),null)):null);
return sci.impl.fns.defmacro_STAR_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5776__auto__);
});

(sci.impl.fns.defmacro_STAR_.cljs$core$IFn$_invoke$arity$variadic = (function (__AMPERSAND_form,__AMPERSAND_env,name,args){
var name__$1 = cljs.core.vary_meta.cljs$core$IFn$_invoke$arity$4(name,cljs.core.assoc,new cljs.core.Keyword(null,"macro","macro",-867863404),true);
var prefix = (function (){var p = (new cljs.core.List(null,name__$1,null,(1),null));
var args__$1 = args;
while(true){
var f = cljs.core.first(args__$1);
if(typeof f === 'string'){
var G__35148 = cljs.core.cons(f,p);
var G__35149 = cljs.core.next(args__$1);
p = G__35148;
args__$1 = G__35149;
continue;
} else {
if(cljs.core.map_QMARK_(f)){
var G__35150 = cljs.core.cons(f,p);
var G__35151 = cljs.core.next(args__$1);
p = G__35150;
args__$1 = G__35151;
continue;
} else {
return p;
}
}
break;
}
})();
var fdecl = (function (){var fd = args;
while(true){
if(typeof cljs.core.first(fd) === 'string'){
var G__35152 = cljs.core.next(fd);
fd = G__35152;
continue;
} else {
if(cljs.core.map_QMARK_(cljs.core.first(fd))){
var G__35153 = cljs.core.next(fd);
fd = G__35153;
continue;
} else {
return fd;
}
}
break;
}
})();
var fdecl__$1 = ((cljs.core.vector_QMARK_(cljs.core.first(fdecl)))?(new cljs.core.List(null,fdecl,null,(1),null)):fdecl);
var add_implicit_args = (function (fd){
var args__$1 = cljs.core.first(fd);
return cljs.core.cons(cljs.core.vec(cljs.core.cons(new cljs.core.Symbol(null,"&form","&form",1482799337,null),cljs.core.cons(new cljs.core.Symbol(null,"&env","&env",-919163083,null),args__$1))),cljs.core.next(fd));
});
var add_args = (function (acc,ds){
while(true){
if((ds == null)){
return acc;
} else {
var d = cljs.core.first(ds);
if(cljs.core.map_QMARK_(d)){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,d);
} else {
var G__35154 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,add_implicit_args(d));
var G__35155 = cljs.core.next(ds);
acc = G__35154;
ds = G__35155;
continue;
}
}
break;
}
});
var fdecl__$2 = cljs.core.seq(add_args(cljs.core.PersistentVector.EMPTY,fdecl__$1));
var decl = (function (){var p = prefix;
var d = fdecl__$2;
while(true){
if(cljs.core.truth_(p)){
var G__35156 = cljs.core.next(p);
var G__35157 = cljs.core.cons(cljs.core.first(p),d);
p = G__35156;
d = G__35157;
continue;
} else {
return d;
}
break;
}
})();
return (new cljs.core.List(null,new cljs.core.Symbol(null,"do","do",1686842252,null),(new cljs.core.List(null,cljs.core.cons(new cljs.core.Symbol("cljs.core","defn","cljs.core/defn",-1606493717,null),decl),(new cljs.core.List(null,(new cljs.core.List(null,new cljs.core.Symbol(null,"var","var",870848730,null),(new cljs.core.List(null,name__$1,null,(1),null)),(2),null)),null,(1),null)),(2),null)),(3),null));
}));

(sci.impl.fns.defmacro_STAR_.cljs$lang$maxFixedArity = (3));

/** @this {Function} */
(sci.impl.fns.defmacro_STAR_.cljs$lang$applyTo = (function (seq34897){
var G__34898 = cljs.core.first(seq34897);
var seq34897__$1 = cljs.core.next(seq34897);
var G__34899 = cljs.core.first(seq34897__$1);
var seq34897__$2 = cljs.core.next(seq34897__$1);
var G__34900 = cljs.core.first(seq34897__$2);
var seq34897__$3 = cljs.core.next(seq34897__$2);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__34898,G__34899,G__34900,seq34897__$3);
}));


//# sourceMappingURL=sci.impl.fns.js.map
