import "./cljs_env.js";
import "./cljs.core.js";
import "./goog.dom.dom.js";
import "./goog.dom.forms.js";
import "./goog.dom.classlist.js";
import "./goog.style.style.js";
import "./goog.style.transition.js";
import "./goog.string.string.js";
import "./clojure.string.js";
import "./cljs.core.async.js";
goog.provide('shadow.dom');
shadow.dom.transition_supported_QMARK_ = (((typeof window !== 'undefined'))?goog.style.transition.isSupported():null);

/**
 * @interface
 */
shadow.dom.IElement = function(){};

var shadow$dom$IElement$_to_dom$dyn_37444 = (function (this$){
var x__5393__auto__ = (((this$ == null))?null:this$);
var m__5394__auto__ = (shadow.dom._to_dom[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$1(this$) : m__5394__auto__.call(null,this$));
} else {
var m__5392__auto__ = (shadow.dom._to_dom["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$1(this$) : m__5392__auto__.call(null,this$));
} else {
throw cljs.core.missing_protocol("IElement.-to-dom",this$);
}
}
});
shadow.dom._to_dom = (function shadow$dom$_to_dom(this$){
if((((!((this$ == null)))) && ((!((this$.shadow$dom$IElement$_to_dom$arity$1 == null)))))){
return this$.shadow$dom$IElement$_to_dom$arity$1(this$);
} else {
return shadow$dom$IElement$_to_dom$dyn_37444(this$);
}
});


/**
 * @interface
 */
shadow.dom.SVGElement = function(){};

var shadow$dom$SVGElement$_to_svg$dyn_37445 = (function (this$){
var x__5393__auto__ = (((this$ == null))?null:this$);
var m__5394__auto__ = (shadow.dom._to_svg[goog.typeOf(x__5393__auto__)]);
if((!((m__5394__auto__ == null)))){
return (m__5394__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5394__auto__.cljs$core$IFn$_invoke$arity$1(this$) : m__5394__auto__.call(null,this$));
} else {
var m__5392__auto__ = (shadow.dom._to_svg["_"]);
if((!((m__5392__auto__ == null)))){
return (m__5392__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5392__auto__.cljs$core$IFn$_invoke$arity$1(this$) : m__5392__auto__.call(null,this$));
} else {
throw cljs.core.missing_protocol("SVGElement.-to-svg",this$);
}
}
});
shadow.dom._to_svg = (function shadow$dom$_to_svg(this$){
if((((!((this$ == null)))) && ((!((this$.shadow$dom$SVGElement$_to_svg$arity$1 == null)))))){
return this$.shadow$dom$SVGElement$_to_svg$arity$1(this$);
} else {
return shadow$dom$SVGElement$_to_svg$dyn_37445(this$);
}
});

shadow.dom.lazy_native_coll_seq = (function shadow$dom$lazy_native_coll_seq(coll,idx){
if((idx < coll.length)){
return (new cljs.core.LazySeq(null,(function (){
return cljs.core.cons((coll[idx]),(function (){var G__36409 = coll;
var G__36410 = (idx + (1));
return (shadow.dom.lazy_native_coll_seq.cljs$core$IFn$_invoke$arity$2 ? shadow.dom.lazy_native_coll_seq.cljs$core$IFn$_invoke$arity$2(G__36409,G__36410) : shadow.dom.lazy_native_coll_seq.call(null,G__36409,G__36410));
})());
}),null,null));
} else {
return null;
}
});

/**
* @constructor
 * @implements {cljs.core.IIndexed}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IDeref}
 * @implements {shadow.dom.IElement}
*/
shadow.dom.NativeColl = (function (coll){
this.coll = coll;
this.cljs$lang$protocol_mask$partition0$ = 8421394;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(shadow.dom.NativeColl.prototype.cljs$core$IDeref$_deref$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return self__.coll;
}));

(shadow.dom.NativeColl.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){
var self__ = this;
var this$__$1 = this;
return (self__.coll[n]);
}));

(shadow.dom.NativeColl.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){
var self__ = this;
var this$__$1 = this;
var or__5045__auto__ = (self__.coll[n]);
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return not_found;
}
}));

(shadow.dom.NativeColl.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return self__.coll.length;
}));

(shadow.dom.NativeColl.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return shadow.dom.lazy_native_coll_seq(self__.coll,(0));
}));

(shadow.dom.NativeColl.prototype.shadow$dom$IElement$ = cljs.core.PROTOCOL_SENTINEL);

(shadow.dom.NativeColl.prototype.shadow$dom$IElement$_to_dom$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return self__.coll;
}));

(shadow.dom.NativeColl.getBasis = (function (){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"coll","coll",-1006698606,null)], null);
}));

(shadow.dom.NativeColl.cljs$lang$type = true);

(shadow.dom.NativeColl.cljs$lang$ctorStr = "shadow.dom/NativeColl");

(shadow.dom.NativeColl.cljs$lang$ctorPrWriter = (function (this__5330__auto__,writer__5331__auto__,opt__5332__auto__){
return cljs.core._write(writer__5331__auto__,"shadow.dom/NativeColl");
}));

/**
 * Positional factory function for shadow.dom/NativeColl.
 */
shadow.dom.__GT_NativeColl = (function shadow$dom$__GT_NativeColl(coll){
return (new shadow.dom.NativeColl(coll));
});

shadow.dom.native_coll = (function shadow$dom$native_coll(coll){
return (new shadow.dom.NativeColl(coll));
});
shadow.dom.dom_node = (function shadow$dom$dom_node(el){
if((el == null)){
return null;
} else {
if((((!((el == null))))?((((false) || ((cljs.core.PROTOCOL_SENTINEL === el.shadow$dom$IElement$))))?true:false):false)){
return el.shadow$dom$IElement$_to_dom$arity$1(null);
} else {
if(typeof el === 'string'){
return document.createTextNode(el);
} else {
if(typeof el === 'number'){
return document.createTextNode(cljs.core.str.cljs$core$IFn$_invoke$arity$1(el));
} else {
return el;

}
}
}
}
});
shadow.dom.query_one = (function shadow$dom$query_one(var_args){
var G__36429 = arguments.length;
switch (G__36429) {
case 1:
return shadow.dom.query_one.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shadow.dom.query_one.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.query_one.cljs$core$IFn$_invoke$arity$1 = (function (sel){
return document.querySelector(sel);
}));

(shadow.dom.query_one.cljs$core$IFn$_invoke$arity$2 = (function (sel,root){
return shadow.dom.dom_node(root).querySelector(sel);
}));

(shadow.dom.query_one.cljs$lang$maxFixedArity = 2);

shadow.dom.query = (function shadow$dom$query(var_args){
var G__36436 = arguments.length;
switch (G__36436) {
case 1:
return shadow.dom.query.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shadow.dom.query.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.query.cljs$core$IFn$_invoke$arity$1 = (function (sel){
return (new shadow.dom.NativeColl(document.querySelectorAll(sel)));
}));

(shadow.dom.query.cljs$core$IFn$_invoke$arity$2 = (function (sel,root){
return (new shadow.dom.NativeColl(shadow.dom.dom_node(root).querySelectorAll(sel)));
}));

(shadow.dom.query.cljs$lang$maxFixedArity = 2);

shadow.dom.by_id = (function shadow$dom$by_id(var_args){
var G__36441 = arguments.length;
switch (G__36441) {
case 2:
return shadow.dom.by_id.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return shadow.dom.by_id.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.by_id.cljs$core$IFn$_invoke$arity$2 = (function (id,el){
return shadow.dom.dom_node(el).getElementById(id);
}));

(shadow.dom.by_id.cljs$core$IFn$_invoke$arity$1 = (function (id){
return document.getElementById(id);
}));

(shadow.dom.by_id.cljs$lang$maxFixedArity = 2);

shadow.dom.build = shadow.dom.dom_node;
shadow.dom.ev_stop = (function shadow$dom$ev_stop(var_args){
var G__36454 = arguments.length;
switch (G__36454) {
case 1:
return shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$1 = (function (e){
if(cljs.core.truth_(e.stopPropagation)){
e.stopPropagation();

e.preventDefault();
} else {
(e.cancelBubble = true);

(e.returnValue = false);
}

return e;
}));

(shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$2 = (function (e,el){
shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$1(e);

return el;
}));

(shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$4 = (function (e,el,scope,owner){
shadow.dom.ev_stop.cljs$core$IFn$_invoke$arity$1(e);

return el;
}));

(shadow.dom.ev_stop.cljs$lang$maxFixedArity = 4);

/**
 * check wether a parent node (or the document) contains the child
 */
shadow.dom.contains_QMARK_ = (function shadow$dom$contains_QMARK_(var_args){
var G__36469 = arguments.length;
switch (G__36469) {
case 1:
return shadow.dom.contains_QMARK_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shadow.dom.contains_QMARK_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.contains_QMARK_.cljs$core$IFn$_invoke$arity$1 = (function (el){
return goog.dom.contains(document,shadow.dom.dom_node(el));
}));

(shadow.dom.contains_QMARK_.cljs$core$IFn$_invoke$arity$2 = (function (parent,el){
return goog.dom.contains(shadow.dom.dom_node(parent),shadow.dom.dom_node(el));
}));

(shadow.dom.contains_QMARK_.cljs$lang$maxFixedArity = 2);

shadow.dom.add_class = (function shadow$dom$add_class(el,cls){
return goog.dom.classlist.add(shadow.dom.dom_node(el),cls);
});
shadow.dom.remove_class = (function shadow$dom$remove_class(el,cls){
return goog.dom.classlist.remove(shadow.dom.dom_node(el),cls);
});
shadow.dom.toggle_class = (function shadow$dom$toggle_class(var_args){
var G__36484 = arguments.length;
switch (G__36484) {
case 2:
return shadow.dom.toggle_class.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shadow.dom.toggle_class.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.toggle_class.cljs$core$IFn$_invoke$arity$2 = (function (el,cls){
return goog.dom.classlist.toggle(shadow.dom.dom_node(el),cls);
}));

(shadow.dom.toggle_class.cljs$core$IFn$_invoke$arity$3 = (function (el,cls,v){
if(cljs.core.truth_(v)){
return shadow.dom.add_class(el,cls);
} else {
return shadow.dom.remove_class(el,cls);
}
}));

(shadow.dom.toggle_class.cljs$lang$maxFixedArity = 3);

shadow.dom.dom_listen = (cljs.core.truth_((function (){var or__5045__auto__ = (!((typeof document !== 'undefined')));
if(or__5045__auto__){
return or__5045__auto__;
} else {
return document.addEventListener;
}
})())?(function shadow$dom$dom_listen_good(el,ev,handler){
return el.addEventListener(ev,handler,false);
}):(function shadow$dom$dom_listen_ie(el,ev,handler){
try{return el.attachEvent(["on",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ev)].join(''),(function (e){
return (handler.cljs$core$IFn$_invoke$arity$2 ? handler.cljs$core$IFn$_invoke$arity$2(e,el) : handler.call(null,e,el));
}));
}catch (e36505){if((e36505 instanceof Object)){
var e = e36505;
return console.log("didnt support attachEvent",el,e);
} else {
throw e36505;

}
}}));
shadow.dom.dom_listen_remove = (cljs.core.truth_((function (){var or__5045__auto__ = (!((typeof document !== 'undefined')));
if(or__5045__auto__){
return or__5045__auto__;
} else {
return document.removeEventListener;
}
})())?(function shadow$dom$dom_listen_remove_good(el,ev,handler){
return el.removeEventListener(ev,handler,false);
}):(function shadow$dom$dom_listen_remove_ie(el,ev,handler){
return el.detachEvent(["on",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ev)].join(''),handler);
}));
shadow.dom.on_query = (function shadow$dom$on_query(root_el,ev,selector,handler){
var seq__36527 = cljs.core.seq(shadow.dom.query.cljs$core$IFn$_invoke$arity$2(selector,root_el));
var chunk__36528 = null;
var count__36529 = (0);
var i__36530 = (0);
while(true){
if((i__36530 < count__36529)){
var el = chunk__36528.cljs$core$IIndexed$_nth$arity$2(null,i__36530);
var handler_37455__$1 = ((function (seq__36527,chunk__36528,count__36529,i__36530,el){
return (function (e){
return (handler.cljs$core$IFn$_invoke$arity$2 ? handler.cljs$core$IFn$_invoke$arity$2(e,el) : handler.call(null,e,el));
});})(seq__36527,chunk__36528,count__36529,i__36530,el))
;
shadow.dom.dom_listen(el,cljs.core.name(ev),handler_37455__$1);


var G__37459 = seq__36527;
var G__37460 = chunk__36528;
var G__37461 = count__36529;
var G__37462 = (i__36530 + (1));
seq__36527 = G__37459;
chunk__36528 = G__37460;
count__36529 = G__37461;
i__36530 = G__37462;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__36527);
if(temp__5804__auto__){
var seq__36527__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__36527__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__36527__$1);
var G__37463 = cljs.core.chunk_rest(seq__36527__$1);
var G__37464 = c__5568__auto__;
var G__37465 = cljs.core.count(c__5568__auto__);
var G__37466 = (0);
seq__36527 = G__37463;
chunk__36528 = G__37464;
count__36529 = G__37465;
i__36530 = G__37466;
continue;
} else {
var el = cljs.core.first(seq__36527__$1);
var handler_37467__$1 = ((function (seq__36527,chunk__36528,count__36529,i__36530,el,seq__36527__$1,temp__5804__auto__){
return (function (e){
return (handler.cljs$core$IFn$_invoke$arity$2 ? handler.cljs$core$IFn$_invoke$arity$2(e,el) : handler.call(null,e,el));
});})(seq__36527,chunk__36528,count__36529,i__36530,el,seq__36527__$1,temp__5804__auto__))
;
shadow.dom.dom_listen(el,cljs.core.name(ev),handler_37467__$1);


var G__37468 = cljs.core.next(seq__36527__$1);
var G__37469 = null;
var G__37470 = (0);
var G__37471 = (0);
seq__36527 = G__37468;
chunk__36528 = G__37469;
count__36529 = G__37470;
i__36530 = G__37471;
continue;
}
} else {
return null;
}
}
break;
}
});
shadow.dom.on = (function shadow$dom$on(var_args){
var G__36606 = arguments.length;
switch (G__36606) {
case 3:
return shadow.dom.on.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shadow.dom.on.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.on.cljs$core$IFn$_invoke$arity$3 = (function (el,ev,handler){
return shadow.dom.on.cljs$core$IFn$_invoke$arity$4(el,ev,handler,false);
}));

(shadow.dom.on.cljs$core$IFn$_invoke$arity$4 = (function (el,ev,handler,capture){
if(cljs.core.vector_QMARK_(ev)){
return shadow.dom.on_query(el,cljs.core.first(ev),cljs.core.second(ev),handler);
} else {
var handler__$1 = (function (e){
return (handler.cljs$core$IFn$_invoke$arity$2 ? handler.cljs$core$IFn$_invoke$arity$2(e,el) : handler.call(null,e,el));
});
return shadow.dom.dom_listen(shadow.dom.dom_node(el),cljs.core.name(ev),handler__$1);
}
}));

(shadow.dom.on.cljs$lang$maxFixedArity = 4);

shadow.dom.remove_event_handler = (function shadow$dom$remove_event_handler(el,ev,handler){
return shadow.dom.dom_listen_remove(shadow.dom.dom_node(el),cljs.core.name(ev),handler);
});
shadow.dom.add_event_listeners = (function shadow$dom$add_event_listeners(el,events){
var seq__36624 = cljs.core.seq(events);
var chunk__36625 = null;
var count__36626 = (0);
var i__36627 = (0);
while(true){
if((i__36627 < count__36626)){
var vec__36641 = chunk__36625.cljs$core$IIndexed$_nth$arity$2(null,i__36627);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36641,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36641,(1),null);
shadow.dom.on.cljs$core$IFn$_invoke$arity$3(el,k,v);


var G__37473 = seq__36624;
var G__37474 = chunk__36625;
var G__37475 = count__36626;
var G__37476 = (i__36627 + (1));
seq__36624 = G__37473;
chunk__36625 = G__37474;
count__36626 = G__37475;
i__36627 = G__37476;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__36624);
if(temp__5804__auto__){
var seq__36624__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__36624__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__36624__$1);
var G__37477 = cljs.core.chunk_rest(seq__36624__$1);
var G__37478 = c__5568__auto__;
var G__37479 = cljs.core.count(c__5568__auto__);
var G__37480 = (0);
seq__36624 = G__37477;
chunk__36625 = G__37478;
count__36626 = G__37479;
i__36627 = G__37480;
continue;
} else {
var vec__36652 = cljs.core.first(seq__36624__$1);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36652,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36652,(1),null);
shadow.dom.on.cljs$core$IFn$_invoke$arity$3(el,k,v);


var G__37481 = cljs.core.next(seq__36624__$1);
var G__37482 = null;
var G__37483 = (0);
var G__37484 = (0);
seq__36624 = G__37481;
chunk__36625 = G__37482;
count__36626 = G__37483;
i__36627 = G__37484;
continue;
}
} else {
return null;
}
}
break;
}
});
shadow.dom.set_style = (function shadow$dom$set_style(el,styles){
var dom = shadow.dom.dom_node(el);
var seq__36662 = cljs.core.seq(styles);
var chunk__36663 = null;
var count__36664 = (0);
var i__36665 = (0);
while(true){
if((i__36665 < count__36664)){
var vec__36679 = chunk__36663.cljs$core$IIndexed$_nth$arity$2(null,i__36665);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36679,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36679,(1),null);
goog.style.setStyle(dom,cljs.core.name(k),(((v == null))?"":v));


var G__37485 = seq__36662;
var G__37486 = chunk__36663;
var G__37487 = count__36664;
var G__37488 = (i__36665 + (1));
seq__36662 = G__37485;
chunk__36663 = G__37486;
count__36664 = G__37487;
i__36665 = G__37488;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__36662);
if(temp__5804__auto__){
var seq__36662__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__36662__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__36662__$1);
var G__37489 = cljs.core.chunk_rest(seq__36662__$1);
var G__37490 = c__5568__auto__;
var G__37491 = cljs.core.count(c__5568__auto__);
var G__37492 = (0);
seq__36662 = G__37489;
chunk__36663 = G__37490;
count__36664 = G__37491;
i__36665 = G__37492;
continue;
} else {
var vec__36686 = cljs.core.first(seq__36662__$1);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36686,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36686,(1),null);
goog.style.setStyle(dom,cljs.core.name(k),(((v == null))?"":v));


var G__37493 = cljs.core.next(seq__36662__$1);
var G__37494 = null;
var G__37495 = (0);
var G__37496 = (0);
seq__36662 = G__37493;
chunk__36663 = G__37494;
count__36664 = G__37495;
i__36665 = G__37496;
continue;
}
} else {
return null;
}
}
break;
}
});
shadow.dom.set_attr_STAR_ = (function shadow$dom$set_attr_STAR_(el,key,value){
var G__36696_37497 = key;
var G__36696_37498__$1 = (((G__36696_37497 instanceof cljs.core.Keyword))?G__36696_37497.fqn:null);
switch (G__36696_37498__$1) {
case "id":
(el.id = cljs.core.str.cljs$core$IFn$_invoke$arity$1(value));

break;
case "class":
(el.className = cljs.core.str.cljs$core$IFn$_invoke$arity$1(value));

break;
case "for":
(el.htmlFor = value);

break;
case "cellpadding":
el.setAttribute("cellPadding",value);

break;
case "cellspacing":
el.setAttribute("cellSpacing",value);

break;
case "colspan":
el.setAttribute("colSpan",value);

break;
case "frameborder":
el.setAttribute("frameBorder",value);

break;
case "height":
el.setAttribute("height",value);

break;
case "maxlength":
el.setAttribute("maxLength",value);

break;
case "role":
el.setAttribute("role",value);

break;
case "rowspan":
el.setAttribute("rowSpan",value);

break;
case "type":
el.setAttribute("type",value);

break;
case "usemap":
el.setAttribute("useMap",value);

break;
case "valign":
el.setAttribute("vAlign",value);

break;
case "width":
el.setAttribute("width",value);

break;
case "on":
shadow.dom.add_event_listeners(el,value);

break;
case "style":
if((value == null)){
} else {
if(typeof value === 'string'){
el.setAttribute("style",value);
} else {
if(cljs.core.map_QMARK_(value)){
shadow.dom.set_style(el,value);
} else {
goog.style.setStyle(el,value);

}
}
}

break;
default:
var ks_37500 = cljs.core.name(key);
if(cljs.core.truth_((function (){var or__5045__auto__ = goog.string.startsWith(ks_37500,"data-");
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return goog.string.startsWith(ks_37500,"aria-");
}
})())){
el.setAttribute(ks_37500,value);
} else {
(el[ks_37500] = value);
}

}

return el;
});
shadow.dom.set_attrs = (function shadow$dom$set_attrs(el,attrs){
return cljs.core.reduce_kv((function (el__$1,key,value){
shadow.dom.set_attr_STAR_(el__$1,key,value);

return el__$1;
}),shadow.dom.dom_node(el),attrs);
});
shadow.dom.set_attr = (function shadow$dom$set_attr(el,key,value){
return shadow.dom.set_attr_STAR_(shadow.dom.dom_node(el),key,value);
});
shadow.dom.has_class_QMARK_ = (function shadow$dom$has_class_QMARK_(el,cls){
return goog.dom.classlist.contains(shadow.dom.dom_node(el),cls);
});
shadow.dom.merge_class_string = (function shadow$dom$merge_class_string(current,extra_class){
if(cljs.core.seq(current)){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(current)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(extra_class)].join('');
} else {
return extra_class;
}
});
shadow.dom.parse_tag = (function shadow$dom$parse_tag(spec){
var spec__$1 = cljs.core.name(spec);
var fdot = spec__$1.indexOf(".");
var fhash = spec__$1.indexOf("#");
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((-1),fdot)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((-1),fhash)))){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [spec__$1,null,null], null);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((-1),fhash)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [spec__$1.substring((0),fdot),null,clojure.string.replace(spec__$1.substring((fdot + (1))),/\./," ")], null);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((-1),fdot)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [spec__$1.substring((0),fhash),spec__$1.substring((fhash + (1))),null], null);
} else {
if((fhash > fdot)){
throw ["cant have id after class?",spec__$1].join('');
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [spec__$1.substring((0),fhash),spec__$1.substring((fhash + (1)),fdot),clojure.string.replace(spec__$1.substring((fdot + (1))),/\./," ")], null);

}
}
}
}
});
shadow.dom.create_dom_node = (function shadow$dom$create_dom_node(tag_def,p__36752){
var map__36753 = p__36752;
var map__36753__$1 = cljs.core.__destructure_map(map__36753);
var props = map__36753__$1;
var class$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__36753__$1,new cljs.core.Keyword(null,"class","class",-2030961996));
var tag_props = ({});
var vec__36755 = shadow.dom.parse_tag(tag_def);
var tag_name = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36755,(0),null);
var tag_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36755,(1),null);
var tag_classes = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36755,(2),null);
if(cljs.core.truth_(tag_id)){
(tag_props["id"] = tag_id);
} else {
}

if(cljs.core.truth_(tag_classes)){
(tag_props["class"] = shadow.dom.merge_class_string(class$,tag_classes));
} else {
}

var G__36763 = goog.dom.createDom(tag_name,tag_props);
shadow.dom.set_attrs(G__36763,cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(props,new cljs.core.Keyword(null,"class","class",-2030961996)));

return G__36763;
});
shadow.dom.append = (function shadow$dom$append(var_args){
var G__36769 = arguments.length;
switch (G__36769) {
case 1:
return shadow.dom.append.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shadow.dom.append.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.append.cljs$core$IFn$_invoke$arity$1 = (function (node){
if(cljs.core.truth_(node)){
var temp__5804__auto__ = shadow.dom.dom_node(node);
if(cljs.core.truth_(temp__5804__auto__)){
var n = temp__5804__auto__;
document.body.appendChild(n);

return n;
} else {
return null;
}
} else {
return null;
}
}));

(shadow.dom.append.cljs$core$IFn$_invoke$arity$2 = (function (el,node){
if(cljs.core.truth_(node)){
var temp__5804__auto__ = shadow.dom.dom_node(node);
if(cljs.core.truth_(temp__5804__auto__)){
var n = temp__5804__auto__;
shadow.dom.dom_node(el).appendChild(n);

return n;
} else {
return null;
}
} else {
return null;
}
}));

(shadow.dom.append.cljs$lang$maxFixedArity = 2);

shadow.dom.destructure_node = (function shadow$dom$destructure_node(create_fn,p__36774){
var vec__36775 = p__36774;
var seq__36776 = cljs.core.seq(vec__36775);
var first__36777 = cljs.core.first(seq__36776);
var seq__36776__$1 = cljs.core.next(seq__36776);
var nn = first__36777;
var first__36777__$1 = cljs.core.first(seq__36776__$1);
var seq__36776__$2 = cljs.core.next(seq__36776__$1);
var np = first__36777__$1;
var nc = seq__36776__$2;
var node = vec__36775;
if((nn instanceof cljs.core.Keyword)){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("invalid dom node",new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"node","node",581201198),node], null));
}

if((((np == null)) && ((nc == null)))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(function (){var G__36778 = nn;
var G__36779 = cljs.core.PersistentArrayMap.EMPTY;
return (create_fn.cljs$core$IFn$_invoke$arity$2 ? create_fn.cljs$core$IFn$_invoke$arity$2(G__36778,G__36779) : create_fn.call(null,G__36778,G__36779));
})(),cljs.core.List.EMPTY], null);
} else {
if(cljs.core.map_QMARK_(np)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(create_fn.cljs$core$IFn$_invoke$arity$2 ? create_fn.cljs$core$IFn$_invoke$arity$2(nn,np) : create_fn.call(null,nn,np)),nc], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(function (){var G__36780 = nn;
var G__36781 = cljs.core.PersistentArrayMap.EMPTY;
return (create_fn.cljs$core$IFn$_invoke$arity$2 ? create_fn.cljs$core$IFn$_invoke$arity$2(G__36780,G__36781) : create_fn.call(null,G__36780,G__36781));
})(),cljs.core.conj.cljs$core$IFn$_invoke$arity$2(nc,np)], null);

}
}
});
shadow.dom.make_dom_node = (function shadow$dom$make_dom_node(structure){
var vec__36784 = shadow.dom.destructure_node(shadow.dom.create_dom_node,structure);
var node = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36784,(0),null);
var node_children = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36784,(1),null);
var seq__36787_37514 = cljs.core.seq(node_children);
var chunk__36788_37515 = null;
var count__36789_37516 = (0);
var i__36790_37517 = (0);
while(true){
if((i__36790_37517 < count__36789_37516)){
var child_struct_37518 = chunk__36788_37515.cljs$core$IIndexed$_nth$arity$2(null,i__36790_37517);
var children_37519 = shadow.dom.dom_node(child_struct_37518);
if(cljs.core.seq_QMARK_(children_37519)){
var seq__36846_37520 = cljs.core.seq(cljs.core.map.cljs$core$IFn$_invoke$arity$2(shadow.dom.dom_node,children_37519));
var chunk__36848_37521 = null;
var count__36849_37522 = (0);
var i__36850_37523 = (0);
while(true){
if((i__36850_37523 < count__36849_37522)){
var child_37524 = chunk__36848_37521.cljs$core$IIndexed$_nth$arity$2(null,i__36850_37523);
if(cljs.core.truth_(child_37524)){
shadow.dom.append.cljs$core$IFn$_invoke$arity$2(node,child_37524);


var G__37525 = seq__36846_37520;
var G__37526 = chunk__36848_37521;
var G__37527 = count__36849_37522;
var G__37528 = (i__36850_37523 + (1));
seq__36846_37520 = G__37525;
chunk__36848_37521 = G__37526;
count__36849_37522 = G__37527;
i__36850_37523 = G__37528;
continue;
} else {
var G__37529 = seq__36846_37520;
var G__37530 = chunk__36848_37521;
var G__37531 = count__36849_37522;
var G__37532 = (i__36850_37523 + (1));
seq__36846_37520 = G__37529;
chunk__36848_37521 = G__37530;
count__36849_37522 = G__37531;
i__36850_37523 = G__37532;
continue;
}
} else {
var temp__5804__auto___37533 = cljs.core.seq(seq__36846_37520);
if(temp__5804__auto___37533){
var seq__36846_37534__$1 = temp__5804__auto___37533;
if(cljs.core.chunked_seq_QMARK_(seq__36846_37534__$1)){
var c__5568__auto___37535 = cljs.core.chunk_first(seq__36846_37534__$1);
var G__37536 = cljs.core.chunk_rest(seq__36846_37534__$1);
var G__37537 = c__5568__auto___37535;
var G__37538 = cljs.core.count(c__5568__auto___37535);
var G__37539 = (0);
seq__36846_37520 = G__37536;
chunk__36848_37521 = G__37537;
count__36849_37522 = G__37538;
i__36850_37523 = G__37539;
continue;
} else {
var child_37540 = cljs.core.first(seq__36846_37534__$1);
if(cljs.core.truth_(child_37540)){
shadow.dom.append.cljs$core$IFn$_invoke$arity$2(node,child_37540);


var G__37541 = cljs.core.next(seq__36846_37534__$1);
var G__37542 = null;
var G__37543 = (0);
var G__37544 = (0);
seq__36846_37520 = G__37541;
chunk__36848_37521 = G__37542;
count__36849_37522 = G__37543;
i__36850_37523 = G__37544;
continue;
} else {
var G__37545 = cljs.core.next(seq__36846_37534__$1);
var G__37546 = null;
var G__37547 = (0);
var G__37548 = (0);
seq__36846_37520 = G__37545;
chunk__36848_37521 = G__37546;
count__36849_37522 = G__37547;
i__36850_37523 = G__37548;
continue;
}
}
} else {
}
}
break;
}
} else {
shadow.dom.append.cljs$core$IFn$_invoke$arity$2(node,children_37519);
}


var G__37549 = seq__36787_37514;
var G__37550 = chunk__36788_37515;
var G__37551 = count__36789_37516;
var G__37552 = (i__36790_37517 + (1));
seq__36787_37514 = G__37549;
chunk__36788_37515 = G__37550;
count__36789_37516 = G__37551;
i__36790_37517 = G__37552;
continue;
} else {
var temp__5804__auto___37553 = cljs.core.seq(seq__36787_37514);
if(temp__5804__auto___37553){
var seq__36787_37554__$1 = temp__5804__auto___37553;
if(cljs.core.chunked_seq_QMARK_(seq__36787_37554__$1)){
var c__5568__auto___37555 = cljs.core.chunk_first(seq__36787_37554__$1);
var G__37556 = cljs.core.chunk_rest(seq__36787_37554__$1);
var G__37557 = c__5568__auto___37555;
var G__37558 = cljs.core.count(c__5568__auto___37555);
var G__37559 = (0);
seq__36787_37514 = G__37556;
chunk__36788_37515 = G__37557;
count__36789_37516 = G__37558;
i__36790_37517 = G__37559;
continue;
} else {
var child_struct_37560 = cljs.core.first(seq__36787_37554__$1);
var children_37561 = shadow.dom.dom_node(child_struct_37560);
if(cljs.core.seq_QMARK_(children_37561)){
var seq__36899_37562 = cljs.core.seq(cljs.core.map.cljs$core$IFn$_invoke$arity$2(shadow.dom.dom_node,children_37561));
var chunk__36901_37563 = null;
var count__36902_37564 = (0);
var i__36903_37565 = (0);
while(true){
if((i__36903_37565 < count__36902_37564)){
var child_37566 = chunk__36901_37563.cljs$core$IIndexed$_nth$arity$2(null,i__36903_37565);
if(cljs.core.truth_(child_37566)){
shadow.dom.append.cljs$core$IFn$_invoke$arity$2(node,child_37566);


var G__37567 = seq__36899_37562;
var G__37568 = chunk__36901_37563;
var G__37569 = count__36902_37564;
var G__37570 = (i__36903_37565 + (1));
seq__36899_37562 = G__37567;
chunk__36901_37563 = G__37568;
count__36902_37564 = G__37569;
i__36903_37565 = G__37570;
continue;
} else {
var G__37571 = seq__36899_37562;
var G__37572 = chunk__36901_37563;
var G__37573 = count__36902_37564;
var G__37574 = (i__36903_37565 + (1));
seq__36899_37562 = G__37571;
chunk__36901_37563 = G__37572;
count__36902_37564 = G__37573;
i__36903_37565 = G__37574;
continue;
}
} else {
var temp__5804__auto___37575__$1 = cljs.core.seq(seq__36899_37562);
if(temp__5804__auto___37575__$1){
var seq__36899_37576__$1 = temp__5804__auto___37575__$1;
if(cljs.core.chunked_seq_QMARK_(seq__36899_37576__$1)){
var c__5568__auto___37577 = cljs.core.chunk_first(seq__36899_37576__$1);
var G__37578 = cljs.core.chunk_rest(seq__36899_37576__$1);
var G__37579 = c__5568__auto___37577;
var G__37580 = cljs.core.count(c__5568__auto___37577);
var G__37581 = (0);
seq__36899_37562 = G__37578;
chunk__36901_37563 = G__37579;
count__36902_37564 = G__37580;
i__36903_37565 = G__37581;
continue;
} else {
var child_37582 = cljs.core.first(seq__36899_37576__$1);
if(cljs.core.truth_(child_37582)){
shadow.dom.append.cljs$core$IFn$_invoke$arity$2(node,child_37582);


var G__37583 = cljs.core.next(seq__36899_37576__$1);
var G__37584 = null;
var G__37585 = (0);
var G__37586 = (0);
seq__36899_37562 = G__37583;
chunk__36901_37563 = G__37584;
count__36902_37564 = G__37585;
i__36903_37565 = G__37586;
continue;
} else {
var G__37587 = cljs.core.next(seq__36899_37576__$1);
var G__37588 = null;
var G__37589 = (0);
var G__37590 = (0);
seq__36899_37562 = G__37587;
chunk__36901_37563 = G__37588;
count__36902_37564 = G__37589;
i__36903_37565 = G__37590;
continue;
}
}
} else {
}
}
break;
}
} else {
shadow.dom.append.cljs$core$IFn$_invoke$arity$2(node,children_37561);
}


var G__37591 = cljs.core.next(seq__36787_37554__$1);
var G__37592 = null;
var G__37593 = (0);
var G__37594 = (0);
seq__36787_37514 = G__37591;
chunk__36788_37515 = G__37592;
count__36789_37516 = G__37593;
i__36790_37517 = G__37594;
continue;
}
} else {
}
}
break;
}

return node;
});
(cljs.core.Keyword.prototype.shadow$dom$IElement$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.Keyword.prototype.shadow$dom$IElement$_to_dom$arity$1 = (function (this$){
var this$__$1 = this;
return shadow.dom.make_dom_node(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [this$__$1], null));
}));

(cljs.core.PersistentVector.prototype.shadow$dom$IElement$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.PersistentVector.prototype.shadow$dom$IElement$_to_dom$arity$1 = (function (this$){
var this$__$1 = this;
return shadow.dom.make_dom_node(this$__$1);
}));

(cljs.core.LazySeq.prototype.shadow$dom$IElement$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.LazySeq.prototype.shadow$dom$IElement$_to_dom$arity$1 = (function (this$){
var this$__$1 = this;
return cljs.core.map.cljs$core$IFn$_invoke$arity$2(shadow.dom._to_dom,this$__$1);
}));
if(cljs.core.truth_(((typeof HTMLElement) != 'undefined'))){
(HTMLElement.prototype.shadow$dom$IElement$ = cljs.core.PROTOCOL_SENTINEL);

(HTMLElement.prototype.shadow$dom$IElement$_to_dom$arity$1 = (function (this$){
var this$__$1 = this;
return this$__$1;
}));
} else {
}
if(cljs.core.truth_(((typeof DocumentFragment) != 'undefined'))){
(DocumentFragment.prototype.shadow$dom$IElement$ = cljs.core.PROTOCOL_SENTINEL);

(DocumentFragment.prototype.shadow$dom$IElement$_to_dom$arity$1 = (function (this$){
var this$__$1 = this;
return this$__$1;
}));
} else {
}
/**
 * clear node children
 */
shadow.dom.reset = (function shadow$dom$reset(node){
return goog.dom.removeChildren(shadow.dom.dom_node(node));
});
shadow.dom.remove = (function shadow$dom$remove(node){
if((((!((node == null))))?(((((node.cljs$lang$protocol_mask$partition0$ & (8388608))) || ((cljs.core.PROTOCOL_SENTINEL === node.cljs$core$ISeqable$))))?true:false):false)){
var seq__36925 = cljs.core.seq(node);
var chunk__36926 = null;
var count__36927 = (0);
var i__36928 = (0);
while(true){
if((i__36928 < count__36927)){
var n = chunk__36926.cljs$core$IIndexed$_nth$arity$2(null,i__36928);
(shadow.dom.remove.cljs$core$IFn$_invoke$arity$1 ? shadow.dom.remove.cljs$core$IFn$_invoke$arity$1(n) : shadow.dom.remove.call(null,n));


var G__37595 = seq__36925;
var G__37596 = chunk__36926;
var G__37597 = count__36927;
var G__37598 = (i__36928 + (1));
seq__36925 = G__37595;
chunk__36926 = G__37596;
count__36927 = G__37597;
i__36928 = G__37598;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__36925);
if(temp__5804__auto__){
var seq__36925__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__36925__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__36925__$1);
var G__37599 = cljs.core.chunk_rest(seq__36925__$1);
var G__37600 = c__5568__auto__;
var G__37601 = cljs.core.count(c__5568__auto__);
var G__37602 = (0);
seq__36925 = G__37599;
chunk__36926 = G__37600;
count__36927 = G__37601;
i__36928 = G__37602;
continue;
} else {
var n = cljs.core.first(seq__36925__$1);
(shadow.dom.remove.cljs$core$IFn$_invoke$arity$1 ? shadow.dom.remove.cljs$core$IFn$_invoke$arity$1(n) : shadow.dom.remove.call(null,n));


var G__37603 = cljs.core.next(seq__36925__$1);
var G__37604 = null;
var G__37605 = (0);
var G__37606 = (0);
seq__36925 = G__37603;
chunk__36926 = G__37604;
count__36927 = G__37605;
i__36928 = G__37606;
continue;
}
} else {
return null;
}
}
break;
}
} else {
return goog.dom.removeNode(node);
}
});
shadow.dom.replace_node = (function shadow$dom$replace_node(old,new$){
return goog.dom.replaceNode(shadow.dom.dom_node(new$),shadow.dom.dom_node(old));
});
shadow.dom.text = (function shadow$dom$text(var_args){
var G__36932 = arguments.length;
switch (G__36932) {
case 2:
return shadow.dom.text.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return shadow.dom.text.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.text.cljs$core$IFn$_invoke$arity$2 = (function (el,new_text){
return (shadow.dom.dom_node(el).innerText = new_text);
}));

(shadow.dom.text.cljs$core$IFn$_invoke$arity$1 = (function (el){
return shadow.dom.dom_node(el).innerText;
}));

(shadow.dom.text.cljs$lang$maxFixedArity = 2);

shadow.dom.check = (function shadow$dom$check(var_args){
var G__36935 = arguments.length;
switch (G__36935) {
case 1:
return shadow.dom.check.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shadow.dom.check.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.check.cljs$core$IFn$_invoke$arity$1 = (function (el){
return shadow.dom.check.cljs$core$IFn$_invoke$arity$2(el,true);
}));

(shadow.dom.check.cljs$core$IFn$_invoke$arity$2 = (function (el,checked){
return (shadow.dom.dom_node(el).checked = checked);
}));

(shadow.dom.check.cljs$lang$maxFixedArity = 2);

shadow.dom.checked_QMARK_ = (function shadow$dom$checked_QMARK_(el){
return shadow.dom.dom_node(el).checked;
});
shadow.dom.form_elements = (function shadow$dom$form_elements(el){
return (new shadow.dom.NativeColl(shadow.dom.dom_node(el).elements));
});
shadow.dom.children = (function shadow$dom$children(el){
return (new shadow.dom.NativeColl(shadow.dom.dom_node(el).children));
});
shadow.dom.child_nodes = (function shadow$dom$child_nodes(el){
return (new shadow.dom.NativeColl(shadow.dom.dom_node(el).childNodes));
});
shadow.dom.attr = (function shadow$dom$attr(var_args){
var G__36951 = arguments.length;
switch (G__36951) {
case 2:
return shadow.dom.attr.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shadow.dom.attr.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.attr.cljs$core$IFn$_invoke$arity$2 = (function (el,key){
return shadow.dom.dom_node(el).getAttribute(cljs.core.name(key));
}));

(shadow.dom.attr.cljs$core$IFn$_invoke$arity$3 = (function (el,key,default$){
var or__5045__auto__ = shadow.dom.dom_node(el).getAttribute(cljs.core.name(key));
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return default$;
}
}));

(shadow.dom.attr.cljs$lang$maxFixedArity = 3);

shadow.dom.del_attr = (function shadow$dom$del_attr(el,key){
return shadow.dom.dom_node(el).removeAttribute(cljs.core.name(key));
});
shadow.dom.data = (function shadow$dom$data(el,key){
return shadow.dom.dom_node(el).getAttribute(["data-",cljs.core.name(key)].join(''));
});
shadow.dom.set_data = (function shadow$dom$set_data(el,key,value){
return shadow.dom.dom_node(el).setAttribute(["data-",cljs.core.name(key)].join(''),cljs.core.str.cljs$core$IFn$_invoke$arity$1(value));
});
shadow.dom.set_html = (function shadow$dom$set_html(node,text){
return (shadow.dom.dom_node(node).innerHTML = text);
});
shadow.dom.get_html = (function shadow$dom$get_html(node){
return shadow.dom.dom_node(node).innerHTML;
});
shadow.dom.fragment = (function shadow$dom$fragment(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37610 = arguments.length;
var i__5770__auto___37611 = (0);
while(true){
if((i__5770__auto___37611 < len__5769__auto___37610)){
args__5775__auto__.push((arguments[i__5770__auto___37611]));

var G__37612 = (i__5770__auto___37611 + (1));
i__5770__auto___37611 = G__37612;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return shadow.dom.fragment.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(shadow.dom.fragment.cljs$core$IFn$_invoke$arity$variadic = (function (nodes){
var fragment = document.createDocumentFragment();
var seq__37003_37613 = cljs.core.seq(nodes);
var chunk__37004_37614 = null;
var count__37005_37615 = (0);
var i__37006_37616 = (0);
while(true){
if((i__37006_37616 < count__37005_37615)){
var node_37617 = chunk__37004_37614.cljs$core$IIndexed$_nth$arity$2(null,i__37006_37616);
fragment.appendChild(shadow.dom._to_dom(node_37617));


var G__37618 = seq__37003_37613;
var G__37619 = chunk__37004_37614;
var G__37620 = count__37005_37615;
var G__37621 = (i__37006_37616 + (1));
seq__37003_37613 = G__37618;
chunk__37004_37614 = G__37619;
count__37005_37615 = G__37620;
i__37006_37616 = G__37621;
continue;
} else {
var temp__5804__auto___37622 = cljs.core.seq(seq__37003_37613);
if(temp__5804__auto___37622){
var seq__37003_37623__$1 = temp__5804__auto___37622;
if(cljs.core.chunked_seq_QMARK_(seq__37003_37623__$1)){
var c__5568__auto___37624 = cljs.core.chunk_first(seq__37003_37623__$1);
var G__37625 = cljs.core.chunk_rest(seq__37003_37623__$1);
var G__37626 = c__5568__auto___37624;
var G__37627 = cljs.core.count(c__5568__auto___37624);
var G__37628 = (0);
seq__37003_37613 = G__37625;
chunk__37004_37614 = G__37626;
count__37005_37615 = G__37627;
i__37006_37616 = G__37628;
continue;
} else {
var node_37629 = cljs.core.first(seq__37003_37623__$1);
fragment.appendChild(shadow.dom._to_dom(node_37629));


var G__37630 = cljs.core.next(seq__37003_37623__$1);
var G__37631 = null;
var G__37632 = (0);
var G__37633 = (0);
seq__37003_37613 = G__37630;
chunk__37004_37614 = G__37631;
count__37005_37615 = G__37632;
i__37006_37616 = G__37633;
continue;
}
} else {
}
}
break;
}

return (new shadow.dom.NativeColl(fragment));
}));

(shadow.dom.fragment.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(shadow.dom.fragment.cljs$lang$applyTo = (function (seq36994){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq36994));
}));

/**
 * given a html string, eval all <script> tags and return the html without the scripts
 * don't do this for everything, only content you trust.
 */
shadow.dom.eval_scripts = (function shadow$dom$eval_scripts(s){
var scripts = cljs.core.re_seq(/<script[^>]*?>(.+?)<\/script>/,s);
var seq__37018_37637 = cljs.core.seq(scripts);
var chunk__37019_37638 = null;
var count__37020_37639 = (0);
var i__37021_37640 = (0);
while(true){
if((i__37021_37640 < count__37020_37639)){
var vec__37031_37645 = chunk__37019_37638.cljs$core$IIndexed$_nth$arity$2(null,i__37021_37640);
var script_tag_37646 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37031_37645,(0),null);
var script_body_37647 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37031_37645,(1),null);
eval(script_body_37647);


var G__37651 = seq__37018_37637;
var G__37652 = chunk__37019_37638;
var G__37653 = count__37020_37639;
var G__37654 = (i__37021_37640 + (1));
seq__37018_37637 = G__37651;
chunk__37019_37638 = G__37652;
count__37020_37639 = G__37653;
i__37021_37640 = G__37654;
continue;
} else {
var temp__5804__auto___37655 = cljs.core.seq(seq__37018_37637);
if(temp__5804__auto___37655){
var seq__37018_37656__$1 = temp__5804__auto___37655;
if(cljs.core.chunked_seq_QMARK_(seq__37018_37656__$1)){
var c__5568__auto___37657 = cljs.core.chunk_first(seq__37018_37656__$1);
var G__37658 = cljs.core.chunk_rest(seq__37018_37656__$1);
var G__37659 = c__5568__auto___37657;
var G__37660 = cljs.core.count(c__5568__auto___37657);
var G__37661 = (0);
seq__37018_37637 = G__37658;
chunk__37019_37638 = G__37659;
count__37020_37639 = G__37660;
i__37021_37640 = G__37661;
continue;
} else {
var vec__37035_37662 = cljs.core.first(seq__37018_37656__$1);
var script_tag_37663 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37035_37662,(0),null);
var script_body_37664 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37035_37662,(1),null);
eval(script_body_37664);


var G__37665 = cljs.core.next(seq__37018_37656__$1);
var G__37666 = null;
var G__37667 = (0);
var G__37668 = (0);
seq__37018_37637 = G__37665;
chunk__37019_37638 = G__37666;
count__37020_37639 = G__37667;
i__37021_37640 = G__37668;
continue;
}
} else {
}
}
break;
}

return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (s__$1,p__37038){
var vec__37039 = p__37038;
var script_tag = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37039,(0),null);
var script_body = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37039,(1),null);
return clojure.string.replace(s__$1,script_tag,"");
}),s,scripts);
});
shadow.dom.str__GT_fragment = (function shadow$dom$str__GT_fragment(s){
var el = document.createElement("div");
(el.innerHTML = s);

return (new shadow.dom.NativeColl(goog.dom.childrenToNode_(document,el)));
});
shadow.dom.node_name = (function shadow$dom$node_name(el){
return shadow.dom.dom_node(el).nodeName;
});
shadow.dom.ancestor_by_class = (function shadow$dom$ancestor_by_class(el,cls){
return goog.dom.getAncestorByClass(shadow.dom.dom_node(el),cls);
});
shadow.dom.ancestor_by_tag = (function shadow$dom$ancestor_by_tag(var_args){
var G__37048 = arguments.length;
switch (G__37048) {
case 2:
return shadow.dom.ancestor_by_tag.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shadow.dom.ancestor_by_tag.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.ancestor_by_tag.cljs$core$IFn$_invoke$arity$2 = (function (el,tag){
return goog.dom.getAncestorByTagNameAndClass(shadow.dom.dom_node(el),cljs.core.name(tag));
}));

(shadow.dom.ancestor_by_tag.cljs$core$IFn$_invoke$arity$3 = (function (el,tag,cls){
return goog.dom.getAncestorByTagNameAndClass(shadow.dom.dom_node(el),cljs.core.name(tag),cljs.core.name(cls));
}));

(shadow.dom.ancestor_by_tag.cljs$lang$maxFixedArity = 3);

shadow.dom.get_value = (function shadow$dom$get_value(dom){
return goog.dom.forms.getValue(shadow.dom.dom_node(dom));
});
shadow.dom.set_value = (function shadow$dom$set_value(dom,value){
return goog.dom.forms.setValue(shadow.dom.dom_node(dom),value);
});
shadow.dom.px = (function shadow$dom$px(value){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1((value | (0))),"px"].join('');
});
shadow.dom.pct = (function shadow$dom$pct(value){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(value),"%"].join('');
});
shadow.dom.remove_style_STAR_ = (function shadow$dom$remove_style_STAR_(el,style){
return el.style.removeProperty(cljs.core.name(style));
});
shadow.dom.remove_style = (function shadow$dom$remove_style(el,style){
var el__$1 = shadow.dom.dom_node(el);
return shadow.dom.remove_style_STAR_(el__$1,style);
});
shadow.dom.remove_styles = (function shadow$dom$remove_styles(el,style_keys){
var el__$1 = shadow.dom.dom_node(el);
var seq__37082 = cljs.core.seq(style_keys);
var chunk__37083 = null;
var count__37084 = (0);
var i__37085 = (0);
while(true){
if((i__37085 < count__37084)){
var it = chunk__37083.cljs$core$IIndexed$_nth$arity$2(null,i__37085);
shadow.dom.remove_style_STAR_(el__$1,it);


var G__37676 = seq__37082;
var G__37677 = chunk__37083;
var G__37678 = count__37084;
var G__37679 = (i__37085 + (1));
seq__37082 = G__37676;
chunk__37083 = G__37677;
count__37084 = G__37678;
i__37085 = G__37679;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__37082);
if(temp__5804__auto__){
var seq__37082__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__37082__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__37082__$1);
var G__37680 = cljs.core.chunk_rest(seq__37082__$1);
var G__37681 = c__5568__auto__;
var G__37682 = cljs.core.count(c__5568__auto__);
var G__37683 = (0);
seq__37082 = G__37680;
chunk__37083 = G__37681;
count__37084 = G__37682;
i__37085 = G__37683;
continue;
} else {
var it = cljs.core.first(seq__37082__$1);
shadow.dom.remove_style_STAR_(el__$1,it);


var G__37684 = cljs.core.next(seq__37082__$1);
var G__37685 = null;
var G__37686 = (0);
var G__37687 = (0);
seq__37082 = G__37684;
chunk__37083 = G__37685;
count__37084 = G__37686;
i__37085 = G__37687;
continue;
}
} else {
return null;
}
}
break;
}
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
shadow.dom.Coordinate = (function (x,y,__meta,__extmap,__hash){
this.x = x;
this.y = y;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(shadow.dom.Coordinate.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__5343__auto__,k__5344__auto__){
var self__ = this;
var this__5343__auto____$1 = this;
return this__5343__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__5344__auto__,null);
}));

(shadow.dom.Coordinate.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__5345__auto__,k37096,else__5346__auto__){
var self__ = this;
var this__5345__auto____$1 = this;
var G__37103 = k37096;
var G__37103__$1 = (((G__37103 instanceof cljs.core.Keyword))?G__37103.fqn:null);
switch (G__37103__$1) {
case "x":
return self__.x;

break;
case "y":
return self__.y;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k37096,else__5346__auto__);

}
}));

(shadow.dom.Coordinate.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__5363__auto__,f__5364__auto__,init__5365__auto__){
var self__ = this;
var this__5363__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__5366__auto__,p__37108){
var vec__37109 = p__37108;
var k__5367__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37109,(0),null);
var v__5368__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37109,(1),null);
return (f__5364__auto__.cljs$core$IFn$_invoke$arity$3 ? f__5364__auto__.cljs$core$IFn$_invoke$arity$3(ret__5366__auto__,k__5367__auto__,v__5368__auto__) : f__5364__auto__.call(null,ret__5366__auto__,k__5367__auto__,v__5368__auto__));
}),init__5365__auto__,this__5363__auto____$1);
}));

(shadow.dom.Coordinate.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__5358__auto__,writer__5359__auto__,opts__5360__auto__){
var self__ = this;
var this__5358__auto____$1 = this;
var pr_pair__5361__auto__ = (function (keyval__5362__auto__){
return cljs.core.pr_sequential_writer(writer__5359__auto__,cljs.core.pr_writer,""," ","",opts__5360__auto__,keyval__5362__auto__);
});
return cljs.core.pr_sequential_writer(writer__5359__auto__,pr_pair__5361__auto__,"#shadow.dom.Coordinate{",", ","}",opts__5360__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"x","x",2099068185),self__.x],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"y","y",-1757859776),self__.y],null))], null),self__.__extmap));
}));

(shadow.dom.Coordinate.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__37095){
var self__ = this;
var G__37095__$1 = this;
return (new cljs.core.RecordIter((0),G__37095__$1,2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"x","x",2099068185),new cljs.core.Keyword(null,"y","y",-1757859776)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(shadow.dom.Coordinate.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__5341__auto__){
var self__ = this;
var this__5341__auto____$1 = this;
return self__.__meta;
}));

(shadow.dom.Coordinate.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__5338__auto__){
var self__ = this;
var this__5338__auto____$1 = this;
return (new shadow.dom.Coordinate(self__.x,self__.y,self__.__meta,self__.__extmap,self__.__hash));
}));

(shadow.dom.Coordinate.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__5347__auto__){
var self__ = this;
var this__5347__auto____$1 = this;
return (2 + cljs.core.count(self__.__extmap));
}));

(shadow.dom.Coordinate.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__5339__auto__){
var self__ = this;
var this__5339__auto____$1 = this;
var h__5154__auto__ = self__.__hash;
if((!((h__5154__auto__ == null)))){
return h__5154__auto__;
} else {
var h__5154__auto____$1 = (function (coll__5340__auto__){
return (145542109 ^ cljs.core.hash_unordered_coll(coll__5340__auto__));
})(this__5339__auto____$1);
(self__.__hash = h__5154__auto____$1);

return h__5154__auto____$1;
}
}));

(shadow.dom.Coordinate.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this37097,other37098){
var self__ = this;
var this37097__$1 = this;
return (((!((other37098 == null)))) && ((((this37097__$1.constructor === other37098.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this37097__$1.x,other37098.x)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this37097__$1.y,other37098.y)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this37097__$1.__extmap,other37098.__extmap)))))))));
}));

(shadow.dom.Coordinate.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__5353__auto__,k__5354__auto__){
var self__ = this;
var this__5353__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"y","y",-1757859776),null,new cljs.core.Keyword(null,"x","x",2099068185),null], null), null),k__5354__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__5353__auto____$1),self__.__meta),k__5354__auto__);
} else {
return (new shadow.dom.Coordinate(self__.x,self__.y,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__5354__auto__)),null));
}
}));

(shadow.dom.Coordinate.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__5350__auto__,k37096){
var self__ = this;
var this__5350__auto____$1 = this;
var G__37120 = k37096;
var G__37120__$1 = (((G__37120 instanceof cljs.core.Keyword))?G__37120.fqn:null);
switch (G__37120__$1) {
case "x":
case "y":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k37096);

}
}));

(shadow.dom.Coordinate.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__5351__auto__,k__5352__auto__,G__37095){
var self__ = this;
var this__5351__auto____$1 = this;
var pred__37121 = cljs.core.keyword_identical_QMARK_;
var expr__37122 = k__5352__auto__;
if(cljs.core.truth_((pred__37121.cljs$core$IFn$_invoke$arity$2 ? pred__37121.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"x","x",2099068185),expr__37122) : pred__37121.call(null,new cljs.core.Keyword(null,"x","x",2099068185),expr__37122)))){
return (new shadow.dom.Coordinate(G__37095,self__.y,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((pred__37121.cljs$core$IFn$_invoke$arity$2 ? pred__37121.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"y","y",-1757859776),expr__37122) : pred__37121.call(null,new cljs.core.Keyword(null,"y","y",-1757859776),expr__37122)))){
return (new shadow.dom.Coordinate(self__.x,G__37095,self__.__meta,self__.__extmap,null));
} else {
return (new shadow.dom.Coordinate(self__.x,self__.y,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__5352__auto__,G__37095),null));
}
}
}));

(shadow.dom.Coordinate.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__5356__auto__){
var self__ = this;
var this__5356__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"x","x",2099068185),self__.x,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"y","y",-1757859776),self__.y,null))], null),self__.__extmap));
}));

(shadow.dom.Coordinate.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__5342__auto__,G__37095){
var self__ = this;
var this__5342__auto____$1 = this;
return (new shadow.dom.Coordinate(self__.x,self__.y,G__37095,self__.__extmap,self__.__hash));
}));

(shadow.dom.Coordinate.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__5348__auto__,entry__5349__auto__){
var self__ = this;
var this__5348__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__5349__auto__)){
return this__5348__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth(entry__5349__auto__,(0)),cljs.core._nth(entry__5349__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__5348__auto____$1,entry__5349__auto__);
}
}));

(shadow.dom.Coordinate.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"x","x",-555367584,null),new cljs.core.Symbol(null,"y","y",-117328249,null)], null);
}));

(shadow.dom.Coordinate.cljs$lang$type = true);

(shadow.dom.Coordinate.cljs$lang$ctorPrSeq = (function (this__5389__auto__){
return (new cljs.core.List(null,"shadow.dom/Coordinate",null,(1),null));
}));

(shadow.dom.Coordinate.cljs$lang$ctorPrWriter = (function (this__5389__auto__,writer__5390__auto__){
return cljs.core._write(writer__5390__auto__,"shadow.dom/Coordinate");
}));

/**
 * Positional factory function for shadow.dom/Coordinate.
 */
shadow.dom.__GT_Coordinate = (function shadow$dom$__GT_Coordinate(x,y){
return (new shadow.dom.Coordinate(x,y,null,null,null));
});

/**
 * Factory function for shadow.dom/Coordinate, taking a map of keywords to field values.
 */
shadow.dom.map__GT_Coordinate = (function shadow$dom$map__GT_Coordinate(G__37100){
var extmap__5385__auto__ = (function (){var G__37143 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__37100,new cljs.core.Keyword(null,"x","x",2099068185),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"y","y",-1757859776)], 0));
if(cljs.core.record_QMARK_(G__37100)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__37143);
} else {
return G__37143;
}
})();
return (new shadow.dom.Coordinate(new cljs.core.Keyword(null,"x","x",2099068185).cljs$core$IFn$_invoke$arity$1(G__37100),new cljs.core.Keyword(null,"y","y",-1757859776).cljs$core$IFn$_invoke$arity$1(G__37100),null,cljs.core.not_empty(extmap__5385__auto__),null));
});

shadow.dom.get_position = (function shadow$dom$get_position(el){
var pos = goog.style.getPosition(shadow.dom.dom_node(el));
return shadow.dom.__GT_Coordinate(pos.x,pos.y);
});
shadow.dom.get_client_position = (function shadow$dom$get_client_position(el){
var pos = goog.style.getClientPosition(shadow.dom.dom_node(el));
return shadow.dom.__GT_Coordinate(pos.x,pos.y);
});
shadow.dom.get_page_offset = (function shadow$dom$get_page_offset(el){
var pos = goog.style.getPageOffset(shadow.dom.dom_node(el));
return shadow.dom.__GT_Coordinate(pos.x,pos.y);
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
shadow.dom.Size = (function (w,h,__meta,__extmap,__hash){
this.w = w;
this.h = h;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(shadow.dom.Size.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__5343__auto__,k__5344__auto__){
var self__ = this;
var this__5343__auto____$1 = this;
return this__5343__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__5344__auto__,null);
}));

(shadow.dom.Size.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__5345__auto__,k37163,else__5346__auto__){
var self__ = this;
var this__5345__auto____$1 = this;
var G__37173 = k37163;
var G__37173__$1 = (((G__37173 instanceof cljs.core.Keyword))?G__37173.fqn:null);
switch (G__37173__$1) {
case "w":
return self__.w;

break;
case "h":
return self__.h;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k37163,else__5346__auto__);

}
}));

(shadow.dom.Size.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__5363__auto__,f__5364__auto__,init__5365__auto__){
var self__ = this;
var this__5363__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__5366__auto__,p__37179){
var vec__37181 = p__37179;
var k__5367__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37181,(0),null);
var v__5368__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37181,(1),null);
return (f__5364__auto__.cljs$core$IFn$_invoke$arity$3 ? f__5364__auto__.cljs$core$IFn$_invoke$arity$3(ret__5366__auto__,k__5367__auto__,v__5368__auto__) : f__5364__auto__.call(null,ret__5366__auto__,k__5367__auto__,v__5368__auto__));
}),init__5365__auto__,this__5363__auto____$1);
}));

(shadow.dom.Size.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__5358__auto__,writer__5359__auto__,opts__5360__auto__){
var self__ = this;
var this__5358__auto____$1 = this;
var pr_pair__5361__auto__ = (function (keyval__5362__auto__){
return cljs.core.pr_sequential_writer(writer__5359__auto__,cljs.core.pr_writer,""," ","",opts__5360__auto__,keyval__5362__auto__);
});
return cljs.core.pr_sequential_writer(writer__5359__auto__,pr_pair__5361__auto__,"#shadow.dom.Size{",", ","}",opts__5360__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"w","w",354169001),self__.w],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"h","h",1109658740),self__.h],null))], null),self__.__extmap));
}));

(shadow.dom.Size.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__37162){
var self__ = this;
var G__37162__$1 = this;
return (new cljs.core.RecordIter((0),G__37162__$1,2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"w","w",354169001),new cljs.core.Keyword(null,"h","h",1109658740)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(shadow.dom.Size.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__5341__auto__){
var self__ = this;
var this__5341__auto____$1 = this;
return self__.__meta;
}));

(shadow.dom.Size.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__5338__auto__){
var self__ = this;
var this__5338__auto____$1 = this;
return (new shadow.dom.Size(self__.w,self__.h,self__.__meta,self__.__extmap,self__.__hash));
}));

(shadow.dom.Size.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__5347__auto__){
var self__ = this;
var this__5347__auto____$1 = this;
return (2 + cljs.core.count(self__.__extmap));
}));

(shadow.dom.Size.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__5339__auto__){
var self__ = this;
var this__5339__auto____$1 = this;
var h__5154__auto__ = self__.__hash;
if((!((h__5154__auto__ == null)))){
return h__5154__auto__;
} else {
var h__5154__auto____$1 = (function (coll__5340__auto__){
return (-1228019642 ^ cljs.core.hash_unordered_coll(coll__5340__auto__));
})(this__5339__auto____$1);
(self__.__hash = h__5154__auto____$1);

return h__5154__auto____$1;
}
}));

(shadow.dom.Size.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this37165,other37166){
var self__ = this;
var this37165__$1 = this;
return (((!((other37166 == null)))) && ((((this37165__$1.constructor === other37166.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this37165__$1.w,other37166.w)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this37165__$1.h,other37166.h)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this37165__$1.__extmap,other37166.__extmap)))))))));
}));

(shadow.dom.Size.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__5353__auto__,k__5354__auto__){
var self__ = this;
var this__5353__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"w","w",354169001),null,new cljs.core.Keyword(null,"h","h",1109658740),null], null), null),k__5354__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__5353__auto____$1),self__.__meta),k__5354__auto__);
} else {
return (new shadow.dom.Size(self__.w,self__.h,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__5354__auto__)),null));
}
}));

(shadow.dom.Size.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__5350__auto__,k37163){
var self__ = this;
var this__5350__auto____$1 = this;
var G__37210 = k37163;
var G__37210__$1 = (((G__37210 instanceof cljs.core.Keyword))?G__37210.fqn:null);
switch (G__37210__$1) {
case "w":
case "h":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k37163);

}
}));

(shadow.dom.Size.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__5351__auto__,k__5352__auto__,G__37162){
var self__ = this;
var this__5351__auto____$1 = this;
var pred__37219 = cljs.core.keyword_identical_QMARK_;
var expr__37220 = k__5352__auto__;
if(cljs.core.truth_((pred__37219.cljs$core$IFn$_invoke$arity$2 ? pred__37219.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"w","w",354169001),expr__37220) : pred__37219.call(null,new cljs.core.Keyword(null,"w","w",354169001),expr__37220)))){
return (new shadow.dom.Size(G__37162,self__.h,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((pred__37219.cljs$core$IFn$_invoke$arity$2 ? pred__37219.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"h","h",1109658740),expr__37220) : pred__37219.call(null,new cljs.core.Keyword(null,"h","h",1109658740),expr__37220)))){
return (new shadow.dom.Size(self__.w,G__37162,self__.__meta,self__.__extmap,null));
} else {
return (new shadow.dom.Size(self__.w,self__.h,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__5352__auto__,G__37162),null));
}
}
}));

(shadow.dom.Size.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__5356__auto__){
var self__ = this;
var this__5356__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"w","w",354169001),self__.w,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"h","h",1109658740),self__.h,null))], null),self__.__extmap));
}));

(shadow.dom.Size.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__5342__auto__,G__37162){
var self__ = this;
var this__5342__auto____$1 = this;
return (new shadow.dom.Size(self__.w,self__.h,G__37162,self__.__extmap,self__.__hash));
}));

(shadow.dom.Size.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__5348__auto__,entry__5349__auto__){
var self__ = this;
var this__5348__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__5349__auto__)){
return this__5348__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth(entry__5349__auto__,(0)),cljs.core._nth(entry__5349__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__5348__auto____$1,entry__5349__auto__);
}
}));

(shadow.dom.Size.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"w","w",1994700528,null),new cljs.core.Symbol(null,"h","h",-1544777029,null)], null);
}));

(shadow.dom.Size.cljs$lang$type = true);

(shadow.dom.Size.cljs$lang$ctorPrSeq = (function (this__5389__auto__){
return (new cljs.core.List(null,"shadow.dom/Size",null,(1),null));
}));

(shadow.dom.Size.cljs$lang$ctorPrWriter = (function (this__5389__auto__,writer__5390__auto__){
return cljs.core._write(writer__5390__auto__,"shadow.dom/Size");
}));

/**
 * Positional factory function for shadow.dom/Size.
 */
shadow.dom.__GT_Size = (function shadow$dom$__GT_Size(w,h){
return (new shadow.dom.Size(w,h,null,null,null));
});

/**
 * Factory function for shadow.dom/Size, taking a map of keywords to field values.
 */
shadow.dom.map__GT_Size = (function shadow$dom$map__GT_Size(G__37168){
var extmap__5385__auto__ = (function (){var G__37235 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__37168,new cljs.core.Keyword(null,"w","w",354169001),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"h","h",1109658740)], 0));
if(cljs.core.record_QMARK_(G__37168)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__37235);
} else {
return G__37235;
}
})();
return (new shadow.dom.Size(new cljs.core.Keyword(null,"w","w",354169001).cljs$core$IFn$_invoke$arity$1(G__37168),new cljs.core.Keyword(null,"h","h",1109658740).cljs$core$IFn$_invoke$arity$1(G__37168),null,cljs.core.not_empty(extmap__5385__auto__),null));
});

shadow.dom.size__GT_clj = (function shadow$dom$size__GT_clj(size){
return (new shadow.dom.Size(size.width,size.height,null,null,null));
});
shadow.dom.get_size = (function shadow$dom$get_size(el){
return shadow.dom.size__GT_clj(goog.style.getSize(shadow.dom.dom_node(el)));
});
shadow.dom.get_height = (function shadow$dom$get_height(el){
return shadow.dom.get_size(el).h;
});
shadow.dom.get_viewport_size = (function shadow$dom$get_viewport_size(){
return shadow.dom.size__GT_clj(goog.dom.getViewportSize());
});
shadow.dom.first_child = (function shadow$dom$first_child(el){
return (shadow.dom.dom_node(el).children[(0)]);
});
shadow.dom.select_option_values = (function shadow$dom$select_option_values(el){
var native$ = shadow.dom.dom_node(el);
var opts = (native$["options"]);
var a__5633__auto__ = opts;
var l__5634__auto__ = a__5633__auto__.length;
var i = (0);
var ret = cljs.core.PersistentVector.EMPTY;
while(true){
if((i < l__5634__auto__)){
var G__37698 = (i + (1));
var G__37699 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,(opts[i]["value"]));
i = G__37698;
ret = G__37699;
continue;
} else {
return ret;
}
break;
}
});
shadow.dom.build_url = (function shadow$dom$build_url(path,query_params){
if(cljs.core.empty_QMARK_(query_params)){
return path;
} else {
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(path),"?",clojure.string.join.cljs$core$IFn$_invoke$arity$2("&",cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p__37286){
var vec__37287 = p__37286;
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37287,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37287,(1),null);
return [cljs.core.name(k),"=",cljs.core.str.cljs$core$IFn$_invoke$arity$1(encodeURIComponent(cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)))].join('');
}),query_params))].join('');
}
});
shadow.dom.redirect = (function shadow$dom$redirect(var_args){
var G__37295 = arguments.length;
switch (G__37295) {
case 1:
return shadow.dom.redirect.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shadow.dom.redirect.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.redirect.cljs$core$IFn$_invoke$arity$1 = (function (path){
return shadow.dom.redirect.cljs$core$IFn$_invoke$arity$2(path,cljs.core.PersistentArrayMap.EMPTY);
}));

(shadow.dom.redirect.cljs$core$IFn$_invoke$arity$2 = (function (path,query_params){
return (document["location"]["href"] = shadow.dom.build_url(path,query_params));
}));

(shadow.dom.redirect.cljs$lang$maxFixedArity = 2);

shadow.dom.reload_BANG_ = (function shadow$dom$reload_BANG_(){
return (document.location.href = document.location.href);
});
shadow.dom.tag_name = (function shadow$dom$tag_name(el){
var dom = shadow.dom.dom_node(el);
return dom.tagName;
});
shadow.dom.insert_after = (function shadow$dom$insert_after(ref,new$){
var new_node = shadow.dom.dom_node(new$);
goog.dom.insertSiblingAfter(new_node,shadow.dom.dom_node(ref));

return new_node;
});
shadow.dom.insert_before = (function shadow$dom$insert_before(ref,new$){
var new_node = shadow.dom.dom_node(new$);
goog.dom.insertSiblingBefore(new_node,shadow.dom.dom_node(ref));

return new_node;
});
shadow.dom.insert_first = (function shadow$dom$insert_first(ref,new$){
var temp__5802__auto__ = shadow.dom.dom_node(ref).firstChild;
if(cljs.core.truth_(temp__5802__auto__)){
var child = temp__5802__auto__;
return shadow.dom.insert_before(child,new$);
} else {
return shadow.dom.append.cljs$core$IFn$_invoke$arity$2(ref,new$);
}
});
shadow.dom.index_of = (function shadow$dom$index_of(el){
var el__$1 = shadow.dom.dom_node(el);
var i = (0);
while(true){
var ps = el__$1.previousSibling;
if((ps == null)){
return i;
} else {
var G__37710 = ps;
var G__37711 = (i + (1));
el__$1 = G__37710;
i = G__37711;
continue;
}
break;
}
});
shadow.dom.get_parent = (function shadow$dom$get_parent(el){
return goog.dom.getParentElement(shadow.dom.dom_node(el));
});
shadow.dom.parents = (function shadow$dom$parents(el){
var parent = shadow.dom.get_parent(el);
if(cljs.core.truth_(parent)){
return cljs.core.cons(parent,(new cljs.core.LazySeq(null,(function (){
return (shadow.dom.parents.cljs$core$IFn$_invoke$arity$1 ? shadow.dom.parents.cljs$core$IFn$_invoke$arity$1(parent) : shadow.dom.parents.call(null,parent));
}),null,null)));
} else {
return null;
}
});
shadow.dom.matches = (function shadow$dom$matches(el,sel){
return shadow.dom.dom_node(el).matches(sel);
});
shadow.dom.get_next_sibling = (function shadow$dom$get_next_sibling(el){
return goog.dom.getNextElementSibling(shadow.dom.dom_node(el));
});
shadow.dom.get_previous_sibling = (function shadow$dom$get_previous_sibling(el){
return goog.dom.getPreviousElementSibling(shadow.dom.dom_node(el));
});
shadow.dom.xmlns = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(new cljs.core.PersistentArrayMap(null, 2, ["svg","http://www.w3.org/2000/svg","xlink","http://www.w3.org/1999/xlink"], null));
shadow.dom.create_svg_node = (function shadow$dom$create_svg_node(tag_def,props){
var vec__37322 = shadow.dom.parse_tag(tag_def);
var tag_name = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37322,(0),null);
var tag_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37322,(1),null);
var tag_classes = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37322,(2),null);
var el = document.createElementNS("http://www.w3.org/2000/svg",tag_name);
if(cljs.core.truth_(tag_id)){
el.setAttribute("id",tag_id);
} else {
}

if(cljs.core.truth_(tag_classes)){
el.setAttribute("class",shadow.dom.merge_class_string(new cljs.core.Keyword(null,"class","class",-2030961996).cljs$core$IFn$_invoke$arity$1(props),tag_classes));
} else {
}

var seq__37326_37712 = cljs.core.seq(props);
var chunk__37327_37713 = null;
var count__37328_37714 = (0);
var i__37329_37715 = (0);
while(true){
if((i__37329_37715 < count__37328_37714)){
var vec__37341_37716 = chunk__37327_37713.cljs$core$IIndexed$_nth$arity$2(null,i__37329_37715);
var k_37717 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37341_37716,(0),null);
var v_37718 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37341_37716,(1),null);
el.setAttributeNS((function (){var temp__5804__auto__ = cljs.core.namespace(k_37717);
if(cljs.core.truth_(temp__5804__auto__)){
var ns = temp__5804__auto__;
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(shadow.dom.xmlns),ns);
} else {
return null;
}
})(),cljs.core.name(k_37717),v_37718);


var G__37719 = seq__37326_37712;
var G__37720 = chunk__37327_37713;
var G__37721 = count__37328_37714;
var G__37722 = (i__37329_37715 + (1));
seq__37326_37712 = G__37719;
chunk__37327_37713 = G__37720;
count__37328_37714 = G__37721;
i__37329_37715 = G__37722;
continue;
} else {
var temp__5804__auto___37723 = cljs.core.seq(seq__37326_37712);
if(temp__5804__auto___37723){
var seq__37326_37724__$1 = temp__5804__auto___37723;
if(cljs.core.chunked_seq_QMARK_(seq__37326_37724__$1)){
var c__5568__auto___37725 = cljs.core.chunk_first(seq__37326_37724__$1);
var G__37726 = cljs.core.chunk_rest(seq__37326_37724__$1);
var G__37727 = c__5568__auto___37725;
var G__37728 = cljs.core.count(c__5568__auto___37725);
var G__37729 = (0);
seq__37326_37712 = G__37726;
chunk__37327_37713 = G__37727;
count__37328_37714 = G__37728;
i__37329_37715 = G__37729;
continue;
} else {
var vec__37344_37730 = cljs.core.first(seq__37326_37724__$1);
var k_37731 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37344_37730,(0),null);
var v_37732 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37344_37730,(1),null);
el.setAttributeNS((function (){var temp__5804__auto____$1 = cljs.core.namespace(k_37731);
if(cljs.core.truth_(temp__5804__auto____$1)){
var ns = temp__5804__auto____$1;
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(shadow.dom.xmlns),ns);
} else {
return null;
}
})(),cljs.core.name(k_37731),v_37732);


var G__37733 = cljs.core.next(seq__37326_37724__$1);
var G__37734 = null;
var G__37735 = (0);
var G__37736 = (0);
seq__37326_37712 = G__37733;
chunk__37327_37713 = G__37734;
count__37328_37714 = G__37735;
i__37329_37715 = G__37736;
continue;
}
} else {
}
}
break;
}

return el;
});
shadow.dom.svg_node = (function shadow$dom$svg_node(el){
if((el == null)){
return null;
} else {
if((((!((el == null))))?((((false) || ((cljs.core.PROTOCOL_SENTINEL === el.shadow$dom$SVGElement$))))?true:false):false)){
return el.shadow$dom$SVGElement$_to_svg$arity$1(null);
} else {
return el;

}
}
});
shadow.dom.make_svg_node = (function shadow$dom$make_svg_node(structure){
var vec__37348 = shadow.dom.destructure_node(shadow.dom.create_svg_node,structure);
var node = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37348,(0),null);
var node_children = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__37348,(1),null);
var seq__37351_37737 = cljs.core.seq(node_children);
var chunk__37353_37738 = null;
var count__37354_37739 = (0);
var i__37355_37740 = (0);
while(true){
if((i__37355_37740 < count__37354_37739)){
var child_struct_37744 = chunk__37353_37738.cljs$core$IIndexed$_nth$arity$2(null,i__37355_37740);
if((!((child_struct_37744 == null)))){
if(typeof child_struct_37744 === 'string'){
var text_37745 = (node["textContent"]);
(node["textContent"] = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(text_37745),child_struct_37744].join(''));
} else {
var children_37746 = shadow.dom.svg_node(child_struct_37744);
if(cljs.core.seq_QMARK_(children_37746)){
var seq__37383_37747 = cljs.core.seq(children_37746);
var chunk__37385_37748 = null;
var count__37386_37749 = (0);
var i__37387_37750 = (0);
while(true){
if((i__37387_37750 < count__37386_37749)){
var child_37751 = chunk__37385_37748.cljs$core$IIndexed$_nth$arity$2(null,i__37387_37750);
if(cljs.core.truth_(child_37751)){
node.appendChild(child_37751);


var G__37752 = seq__37383_37747;
var G__37753 = chunk__37385_37748;
var G__37754 = count__37386_37749;
var G__37755 = (i__37387_37750 + (1));
seq__37383_37747 = G__37752;
chunk__37385_37748 = G__37753;
count__37386_37749 = G__37754;
i__37387_37750 = G__37755;
continue;
} else {
var G__37759 = seq__37383_37747;
var G__37760 = chunk__37385_37748;
var G__37761 = count__37386_37749;
var G__37762 = (i__37387_37750 + (1));
seq__37383_37747 = G__37759;
chunk__37385_37748 = G__37760;
count__37386_37749 = G__37761;
i__37387_37750 = G__37762;
continue;
}
} else {
var temp__5804__auto___37763 = cljs.core.seq(seq__37383_37747);
if(temp__5804__auto___37763){
var seq__37383_37764__$1 = temp__5804__auto___37763;
if(cljs.core.chunked_seq_QMARK_(seq__37383_37764__$1)){
var c__5568__auto___37765 = cljs.core.chunk_first(seq__37383_37764__$1);
var G__37766 = cljs.core.chunk_rest(seq__37383_37764__$1);
var G__37767 = c__5568__auto___37765;
var G__37768 = cljs.core.count(c__5568__auto___37765);
var G__37769 = (0);
seq__37383_37747 = G__37766;
chunk__37385_37748 = G__37767;
count__37386_37749 = G__37768;
i__37387_37750 = G__37769;
continue;
} else {
var child_37770 = cljs.core.first(seq__37383_37764__$1);
if(cljs.core.truth_(child_37770)){
node.appendChild(child_37770);


var G__37771 = cljs.core.next(seq__37383_37764__$1);
var G__37772 = null;
var G__37773 = (0);
var G__37774 = (0);
seq__37383_37747 = G__37771;
chunk__37385_37748 = G__37772;
count__37386_37749 = G__37773;
i__37387_37750 = G__37774;
continue;
} else {
var G__37775 = cljs.core.next(seq__37383_37764__$1);
var G__37776 = null;
var G__37777 = (0);
var G__37778 = (0);
seq__37383_37747 = G__37775;
chunk__37385_37748 = G__37776;
count__37386_37749 = G__37777;
i__37387_37750 = G__37778;
continue;
}
}
} else {
}
}
break;
}
} else {
node.appendChild(children_37746);
}
}


var G__37779 = seq__37351_37737;
var G__37780 = chunk__37353_37738;
var G__37781 = count__37354_37739;
var G__37782 = (i__37355_37740 + (1));
seq__37351_37737 = G__37779;
chunk__37353_37738 = G__37780;
count__37354_37739 = G__37781;
i__37355_37740 = G__37782;
continue;
} else {
var G__37783 = seq__37351_37737;
var G__37784 = chunk__37353_37738;
var G__37785 = count__37354_37739;
var G__37786 = (i__37355_37740 + (1));
seq__37351_37737 = G__37783;
chunk__37353_37738 = G__37784;
count__37354_37739 = G__37785;
i__37355_37740 = G__37786;
continue;
}
} else {
var temp__5804__auto___37787 = cljs.core.seq(seq__37351_37737);
if(temp__5804__auto___37787){
var seq__37351_37788__$1 = temp__5804__auto___37787;
if(cljs.core.chunked_seq_QMARK_(seq__37351_37788__$1)){
var c__5568__auto___37789 = cljs.core.chunk_first(seq__37351_37788__$1);
var G__37790 = cljs.core.chunk_rest(seq__37351_37788__$1);
var G__37791 = c__5568__auto___37789;
var G__37792 = cljs.core.count(c__5568__auto___37789);
var G__37793 = (0);
seq__37351_37737 = G__37790;
chunk__37353_37738 = G__37791;
count__37354_37739 = G__37792;
i__37355_37740 = G__37793;
continue;
} else {
var child_struct_37794 = cljs.core.first(seq__37351_37788__$1);
if((!((child_struct_37794 == null)))){
if(typeof child_struct_37794 === 'string'){
var text_37795 = (node["textContent"]);
(node["textContent"] = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(text_37795),child_struct_37794].join(''));
} else {
var children_37796 = shadow.dom.svg_node(child_struct_37794);
if(cljs.core.seq_QMARK_(children_37796)){
var seq__37392_37797 = cljs.core.seq(children_37796);
var chunk__37394_37798 = null;
var count__37395_37799 = (0);
var i__37396_37800 = (0);
while(true){
if((i__37396_37800 < count__37395_37799)){
var child_37801 = chunk__37394_37798.cljs$core$IIndexed$_nth$arity$2(null,i__37396_37800);
if(cljs.core.truth_(child_37801)){
node.appendChild(child_37801);


var G__37802 = seq__37392_37797;
var G__37803 = chunk__37394_37798;
var G__37804 = count__37395_37799;
var G__37805 = (i__37396_37800 + (1));
seq__37392_37797 = G__37802;
chunk__37394_37798 = G__37803;
count__37395_37799 = G__37804;
i__37396_37800 = G__37805;
continue;
} else {
var G__37809 = seq__37392_37797;
var G__37810 = chunk__37394_37798;
var G__37811 = count__37395_37799;
var G__37812 = (i__37396_37800 + (1));
seq__37392_37797 = G__37809;
chunk__37394_37798 = G__37810;
count__37395_37799 = G__37811;
i__37396_37800 = G__37812;
continue;
}
} else {
var temp__5804__auto___37813__$1 = cljs.core.seq(seq__37392_37797);
if(temp__5804__auto___37813__$1){
var seq__37392_37814__$1 = temp__5804__auto___37813__$1;
if(cljs.core.chunked_seq_QMARK_(seq__37392_37814__$1)){
var c__5568__auto___37815 = cljs.core.chunk_first(seq__37392_37814__$1);
var G__37816 = cljs.core.chunk_rest(seq__37392_37814__$1);
var G__37817 = c__5568__auto___37815;
var G__37818 = cljs.core.count(c__5568__auto___37815);
var G__37819 = (0);
seq__37392_37797 = G__37816;
chunk__37394_37798 = G__37817;
count__37395_37799 = G__37818;
i__37396_37800 = G__37819;
continue;
} else {
var child_37820 = cljs.core.first(seq__37392_37814__$1);
if(cljs.core.truth_(child_37820)){
node.appendChild(child_37820);


var G__37821 = cljs.core.next(seq__37392_37814__$1);
var G__37822 = null;
var G__37823 = (0);
var G__37824 = (0);
seq__37392_37797 = G__37821;
chunk__37394_37798 = G__37822;
count__37395_37799 = G__37823;
i__37396_37800 = G__37824;
continue;
} else {
var G__37825 = cljs.core.next(seq__37392_37814__$1);
var G__37826 = null;
var G__37827 = (0);
var G__37828 = (0);
seq__37392_37797 = G__37825;
chunk__37394_37798 = G__37826;
count__37395_37799 = G__37827;
i__37396_37800 = G__37828;
continue;
}
}
} else {
}
}
break;
}
} else {
node.appendChild(children_37796);
}
}


var G__37829 = cljs.core.next(seq__37351_37788__$1);
var G__37830 = null;
var G__37831 = (0);
var G__37832 = (0);
seq__37351_37737 = G__37829;
chunk__37353_37738 = G__37830;
count__37354_37739 = G__37831;
i__37355_37740 = G__37832;
continue;
} else {
var G__37833 = cljs.core.next(seq__37351_37788__$1);
var G__37834 = null;
var G__37835 = (0);
var G__37836 = (0);
seq__37351_37737 = G__37833;
chunk__37353_37738 = G__37834;
count__37354_37739 = G__37835;
i__37355_37740 = G__37836;
continue;
}
}
} else {
}
}
break;
}

return node;
});
(shadow.dom.SVGElement["string"] = true);

(shadow.dom._to_svg["string"] = (function (this$){
if((this$ instanceof cljs.core.Keyword)){
return shadow.dom.make_svg_node(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [this$], null));
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("strings cannot be in svgs",new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"this","this",-611633625),this$], null));
}
}));

(cljs.core.PersistentVector.prototype.shadow$dom$SVGElement$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.PersistentVector.prototype.shadow$dom$SVGElement$_to_svg$arity$1 = (function (this$){
var this$__$1 = this;
return shadow.dom.make_svg_node(this$__$1);
}));

(cljs.core.LazySeq.prototype.shadow$dom$SVGElement$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.LazySeq.prototype.shadow$dom$SVGElement$_to_svg$arity$1 = (function (this$){
var this$__$1 = this;
return cljs.core.map.cljs$core$IFn$_invoke$arity$2(shadow.dom._to_svg,this$__$1);
}));

(shadow.dom.SVGElement["null"] = true);

(shadow.dom._to_svg["null"] = (function (_){
return null;
}));
shadow.dom.svg = (function shadow$dom$svg(var_args){
var args__5775__auto__ = [];
var len__5769__auto___37843 = arguments.length;
var i__5770__auto___37844 = (0);
while(true){
if((i__5770__auto___37844 < len__5769__auto___37843)){
args__5775__auto__.push((arguments[i__5770__auto___37844]));

var G__37845 = (i__5770__auto___37844 + (1));
i__5770__auto___37844 = G__37845;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((1) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((1)),(0),null)):null);
return shadow.dom.svg.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5776__auto__);
});

(shadow.dom.svg.cljs$core$IFn$_invoke$arity$variadic = (function (attrs,children){
return shadow.dom._to_svg(cljs.core.vec(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"svg","svg",856789142),attrs], null),children)));
}));

(shadow.dom.svg.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(shadow.dom.svg.cljs$lang$applyTo = (function (seq37398){
var G__37399 = cljs.core.first(seq37398);
var seq37398__$1 = cljs.core.next(seq37398);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__37399,seq37398__$1);
}));

/**
 * returns a channel for events on el
 * transform-fn should be a (fn [e el] some-val) where some-val will be put on the chan
 * once-or-cleanup handles the removal of the event handler
 * - true: remove after one event
 * - false: never removed
 * - chan: remove on msg/close
 */
shadow.dom.event_chan = (function shadow$dom$event_chan(var_args){
var G__37404 = arguments.length;
switch (G__37404) {
case 2:
return shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$2 = (function (el,event){
return shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$4(el,event,null,false);
}));

(shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$3 = (function (el,event,xf){
return shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$4(el,event,xf,false);
}));

(shadow.dom.event_chan.cljs$core$IFn$_invoke$arity$4 = (function (el,event,xf,once_or_cleanup){
var buf = cljs.core.async.sliding_buffer((1));
var chan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2(buf,xf);
var event_fn = (function shadow$dom$event_fn(e){
cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(chan,e);

if(once_or_cleanup === true){
shadow.dom.remove_event_handler(el,event,shadow$dom$event_fn);

return cljs.core.async.close_BANG_(chan);
} else {
return null;
}
});
shadow.dom.dom_listen(shadow.dom.dom_node(el),cljs.core.name(event),event_fn);

if(cljs.core.truth_((function (){var and__5043__auto__ = once_or_cleanup;
if(cljs.core.truth_(and__5043__auto__)){
return (!(once_or_cleanup === true));
} else {
return and__5043__auto__;
}
})())){
var c__33371__auto___37847 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__33372__auto__ = (function (){var switch__33218__auto__ = (function (state_37409){
var state_val_37410 = (state_37409[(1)]);
if((state_val_37410 === (1))){
var state_37409__$1 = state_37409;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37409__$1,(2),once_or_cleanup);
} else {
if((state_val_37410 === (2))){
var inst_37406 = (state_37409[(2)]);
var inst_37407 = shadow.dom.remove_event_handler(el,event,event_fn);
var state_37409__$1 = (function (){var statearr_37426 = state_37409;
(statearr_37426[(7)] = inst_37406);

return statearr_37426;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_37409__$1,inst_37407);
} else {
return null;
}
}
});
return (function() {
var shadow$dom$state_machine__33219__auto__ = null;
var shadow$dom$state_machine__33219__auto____0 = (function (){
var statearr_37430 = [null,null,null,null,null,null,null,null];
(statearr_37430[(0)] = shadow$dom$state_machine__33219__auto__);

(statearr_37430[(1)] = (1));

return statearr_37430;
});
var shadow$dom$state_machine__33219__auto____1 = (function (state_37409){
while(true){
var ret_value__33220__auto__ = (function (){try{while(true){
var result__33221__auto__ = switch__33218__auto__(state_37409);
if(cljs.core.keyword_identical_QMARK_(result__33221__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__33221__auto__;
}
break;
}
}catch (e37431){var ex__33222__auto__ = e37431;
var statearr_37432_37848 = state_37409;
(statearr_37432_37848[(2)] = ex__33222__auto__);


if(cljs.core.seq((state_37409[(4)]))){
var statearr_37433_37849 = state_37409;
(statearr_37433_37849[(1)] = cljs.core.first((state_37409[(4)])));

} else {
throw ex__33222__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__33220__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37850 = state_37409;
state_37409 = G__37850;
continue;
} else {
return ret_value__33220__auto__;
}
break;
}
});
shadow$dom$state_machine__33219__auto__ = function(state_37409){
switch(arguments.length){
case 0:
return shadow$dom$state_machine__33219__auto____0.call(this);
case 1:
return shadow$dom$state_machine__33219__auto____1.call(this,state_37409);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shadow$dom$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$0 = shadow$dom$state_machine__33219__auto____0;
shadow$dom$state_machine__33219__auto__.cljs$core$IFn$_invoke$arity$1 = shadow$dom$state_machine__33219__auto____1;
return shadow$dom$state_machine__33219__auto__;
})()
})();
var state__33373__auto__ = (function (){var statearr_37434 = f__33372__auto__();
(statearr_37434[(6)] = c__33371__auto___37847);

return statearr_37434;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__33373__auto__);
}));

} else {
}

return chan;
}));

(shadow.dom.event_chan.cljs$lang$maxFixedArity = 4);


//# sourceMappingURL=shadow.dom.js.map
